SystemOrganization addCategory: #'Mondrian-Core'!

!Point methodsFor: '*mondrian-core-accessing' stamp: 'lr 2/3/2008 13:35'!
moX: aNumber 
	x := aNumber! !

!Point methodsFor: '*mondrian-core-accessing' stamp: 'lr 2/3/2008 13:36'!
moY: aNumber 
	y := aNumber! !

!Point methodsFor: '*mondrian-core-accessing' stamp: 'AlexandreBergel 2/17/2009 18:09'!
translatedBy: amount 
	"Answer a new object translated by amount, which can be
	a Point or a scalar value."
	
	"For compatibility, used in layouts"

	^self + amount! !

!CompiledMethod methodsFor: '*mondrian-core-literals' stamp: 'Alexandre Bergel 4/26/2010 11:25'!
classReferences
	^ ((self allLiterals select: [:l | l isKindOf: Association ]) collect: #value) copyWithout: self methodClass
	! !

!CompiledMethod methodsFor: '*mondrian-core-literals' stamp: 'Alexandre Bergel 5/10/2010 18:58'!
numberOfLinesOfCode
	(self propertyValueAt: #numberOfLinesOfCode)
			ifNil: [ self propertyValueAt: #numberOfLinesOfCode put: self getSource lineCount ].

	^ self propertyValueAt: #numberOfLinesOfCode ! !

!Color class methodsFor: '*mondrian-core-accessing' stamp: 'TudorGirba 3/22/2011 12:24'!
lightColors
	^OrderedCollection new
		"red"
		add: (Color 
					h: Color red hue
					s: 0.3
					v: Color red brightness);
		"blue"
		add: (Color 
					h: Color blue hue
					s: 0.3
					v: Color blue brightness);
		"orange"
		add: (Color 
					h: Color orange hue
					s: 0.3
					v: Color orange brightness);
		"cyan"
		add: (Color 
					h: Color cyan hue
					s: 0.3 
					v: Color cyan brightness );
		"green"
		add: (Color 
					h: Color lightGreen hue
					s: 0.1
					v: 0.7);
		"pink"
		add: (Color 
					h: Color pink hue
					s: 0.1
					v: Color pink brightness);
		"brown"
		add: (Color 
					h: Color brown hue
					s: 0.2
					v: 1 );
		"purple"
		add: (Color 
					h: Color purple hue
					s: 0.2
					v: Color purple brightness );
		"yellow"
		add: (Color 
					h: Color yellow hue
					s: 0.3
					v: Color yellow brightness);
		"gray"
		add: (Color veryLightGray);
		yourself;


		yourself! !

!Color class methodsFor: '*mondrian-core-accessing' stamp: 'Alexandre.Bergel 4/20/2009 18:28'!
pink
 	^ self r: 1.0 g: 0.752899 b: 0.796118.! !

!Color class methodsFor: '*mondrian-core-accessing' stamp: 'simon.denier 7/24/2009 18:22'!
purple
 	^ self r: 0.4 g: 0.0 b: 0.6.! !

!Color class methodsFor: '*mondrian-core-accessing' stamp: 'Alexandre Bergel 7/26/2010 12:21'!
strongColors
	^(OrderedCollection new)
			add: self red;
			add: self blue;
			add: self orange;
			add: self cyan;
			add: self green;
			add: self pink;
			add: self brown;
			add: self purple;
			add: self yellow;
			add: self gray;
			yourself! !

!BlockContext methodsFor: '*mondrian-core-evaluating' stamp: 'AlexandreBergel 11/19/2010 17:32'!
moValue: valueOrArray
	self numArgs = 0 ifTrue: [ ^ self value ].  
	self numArgs = 1 ifTrue: [ ^ self value: valueOrArray ].
	
	"if I have more than 1 argument, then the valueOrArray is a collection"
	valueOrArray isCollection ifFalse: [ self error: 'A block with more than one argument can only be evaluated with a collection ' ].
	
	self numArgs = valueOrArray size ifTrue: [ ^ self valueWithArguments: valueOrArray ]. 
	
	self error: 'Incorrect number of arguments'

! !

!Behavior methodsFor: '*mondrian-core-accessing' stamp: 'AlexandreBergel 5/18/2011 10:48'!
initializedInstance
	"Answer an instance of the receiver which in some sense is initialized.  In the case of Morphs, this will yield an instance that can be attached to the Hand after having received the same kind of basic initialization that would be obtained from an instance chosen from the 'new morph' menu.   Return nil if the receiver is reluctant for some reason to return such a thing"

	^ self new! !

!Behavior methodsFor: '*mondrian-core-accessing' stamp: 'Alexandre Bergel 4/21/2010 21:13'!
numberOfAttributes
	^ self instVarNames size! !

!Behavior methodsFor: '*mondrian-core-accessing' stamp: 'AlexandreBergel 6/26/2011 18:32'!
numberOfAttributesInherited
	^ self allSuperclasses inject: 0 into: [:sum :el | sum + el instVarNames size]! !

!Behavior methodsFor: '*mondrian-core-accessing' stamp: 'AlexandreBergel 6/26/2011 18:32'!
numberOfMethodsInherited
	^ self allSuperclasses inject: 0 into: [:sum :el | sum + el methods size  ]! !

!Behavior methodsFor: '*mondrian-core-accessing' stamp: 'AlexandreBergel 12/27/2011 10:11'!
referencedClasses
	"Return the list of classes referenced by my methods"

	| listOfClasses |
	listOfClasses := Set new.
	self methods do: [:m | listOfClasses 
			addAll: ((m allLiterals select: [:l | (l isKindOf: Association) and: [ l value isBehavior ]]) collect: #value) ].
	^ listOfClasses! !

!BlockClosure methodsFor: '*mondrian-core-evaluating' stamp: 'AlexandreBergel 11/19/2010 17:31'!
moValue: valueOrArray
	self numArgs = 0 ifTrue: [ ^ self value ].  
	self numArgs = 1 ifTrue: [ ^ self value: valueOrArray ].
	
	"if I have more than 1 argument, then the valueOrArray is a collection"
	valueOrArray isCollection ifFalse: [ self error: 'A block with more than one argument can only be evaluated with a collection ' ].
	
	self numArgs = valueOrArray size ifTrue: [ ^ self valueWithArguments: valueOrArray ]. 
	
	self error: 'Incorrect number of arguments'

! !

!BlockClosure methodsFor: '*mondrian-core-evaluating' stamp: 'AlexandreBergel 12/21/2010 13:58'!
returnTrue
	^ true! !

!Rectangle methodsFor: '*mondrian-core-accessing' stamp: 'lr 9/18/2006 15:38'!
corner: aPoint
	corner := aPoint! !

!Rectangle methodsFor: '*mondrian-core-accessing' stamp: 'Alexandre.Bergel 2/5/2009 18:47'!
extent: aPoint
	corner := origin + aPoint! !

!Rectangle methodsFor: '*mondrian-core-accessing' stamp: 'lr 2/3/2008 13:36'!
height: aNumber 
	corner moY: origin y + aNumber! !

!Rectangle methodsFor: '*mondrian-core-accessing' stamp: 'lr 9/18/2006 15:38'!
origin: aPoint
	origin := aPoint! !

!Rectangle methodsFor: '*mondrian-core-accessing' stamp: 'Alexandre.Bergel 2/21/2009 13:07'!
translate: aPoint
	origin := origin + aPoint.
	corner := corner + aPoint! !

!Rectangle methodsFor: '*mondrian-core-accessing' stamp: 'Alexandre Bergel 3/2/2010 14:15'!
translateTo: aPoint	
	| currentExtent |

	currentExtent := self extent.
	origin := aPoint.
	self extent: currentExtent! !

!Rectangle methodsFor: '*mondrian-core-accessing' stamp: 'lr 2/3/2008 13:35'!
width: aNumber 
	corner moX: origin x + aNumber! !

!Symbol methodsFor: '*mondrian-core' stamp: 'lr 2/3/2008 13:34'!
moValue: anObject 
	^ anObject perform: self! !

!Collection methodsFor: '*mondrian-core-util' stamp: 'Alexandre.Bergel 8/30/2009 11:01'!
maxValue: aBlock
	"Evaluate aBlock for element of the receiver, and return the largest result."

	^self inject: Float infinity negated into: [ :max :each | max max: (aBlock value: each) ]! !

!Collection methodsFor: '*mondrian-core-util' stamp: 'AlexandreBergel 9/18/2010 11:00'!
sortedAs: aSortBlockOrSymbol
	"Answer a SortedCollection whose elements are the elements of the 
	receiver. The sort order is defined by the argument, aSortBlock."

	| aSortedCollection aSortBlock |
	aSortedCollection := SortedCollection new: self size.
	aSortBlock := 
		aSortBlockOrSymbol isSymbol 
			ifTrue: [ [:a :b | |t1 t2|
							t1 := (a perform: aSortBlockOrSymbol).
							t2 := (b perform: aSortBlockOrSymbol).
							((t1 isKindOf: Boolean) and: [t2 isKindOf: Boolean])
								ifTrue: [ t1 ]
								ifFalse: [ t1 < t2 ] ] ]
			ifFalse: [ 
				(aSortBlockOrSymbol numArgs = 1)
					ifTrue: [ [ :v1 :v2 | (aSortBlockOrSymbol value: v1) < (aSortBlockOrSymbol value: v2) ] ]
					ifFalse: [ aSortBlockOrSymbol ] ].
	aSortedCollection sortBlock: aSortBlock.
	aSortedCollection addAll: self.
	^ aSortedCollection! !

Object subclass: #MOElementShapeProperties
	instanceVariableNames: 'shape symbol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

!MOElementShapeProperties commentStamp: 'AlexandreBergel 4/11/2011 16:55' prior: 0!
MOElementShapeProperties represents an entry in the cache dictionary present in each MOGraphElement

Instance Variables:
	Shape 		<MOShape>	Instance of the shape 
	symbol		<Symbol>	Symbol that represents the cache!

!MOElementShapeProperties classSide methodsFor: 'instantiation' stamp: 'AlexandreBergel 4/11/2011 16:56'!
new
	self error: 'Please use shape:key: to instantiate'! !

!MOElementShapeProperties classSide methodsFor: 'instantiation' stamp: 'AlexandreBergel 4/11/2011 16:56'!
shape: aShape key: aSymbol
	^ super new 
		shape: aShape;
		symbol: aSymbol;
		yourself! !

!MOElementShapeProperties methodsFor: 'equality' stamp: 'AlexandreBergel 4/11/2011 17:04'!
= anotherMOElementShapeProperty
	^ self class == anotherMOElementShapeProperty class
		ifTrue: [ shape == anotherMOElementShapeProperty shape 
				and: [ symbol == anotherMOElementShapeProperty symbol]]
		ifFalse: [ super = anotherMOElementShapeProperty ]! !

!MOElementShapeProperties methodsFor: 'equality' stamp: 'AlexandreBergel 4/11/2011 17:11'!
hash
	^ shape hash bitXor: symbol hash! !

!MOElementShapeProperties methodsFor: 'accessing' stamp: 'AlexandreBergel 4/11/2011 16:56'!
shape
	^ shape! !

!MOElementShapeProperties methodsFor: 'accessing' stamp: 'AlexandreBergel 4/11/2011 16:56'!
shape: anObject
	shape := anObject! !

!MOElementShapeProperties methodsFor: 'accessing' stamp: 'AlexandreBergel 4/11/2011 16:56'!
symbol
	^ symbol! !

!MOElementShapeProperties methodsFor: 'accessing' stamp: 'AlexandreBergel 4/11/2011 16:56'!
symbol: anObject
	symbol := anObject! !

Object subclass: #MOGraphElement
	instanceVariableNames: 'model owner announcer isSelected shape cacheShapeBounds boundsCache layout popup absoluteBoundsCache attributes zOrder cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

!MOGraphElement commentStamp: 'AlexandreBergel 12/7/2010 11:47' prior: 0!
MOGraphElement is the root of the element hierarchy in Mondrian

Instance Variables:
	model	<Object> 					Value represended by me, the graph element
	owner	<MOGraphElement> 		Link to the nesting node
	announcer	<Announcer> 			Announcer of the graph element
	edges	<SequenceableCollection>	List of edges contained in the graph element
	isSelected	<Boolean>				Whether it is selected or not. 
	shape	<Object>					Shape of the object
	cacheShapeBounds	<SmallDictionary>	List of caches. Essentially used by MOFormBuilder
	cacheForm	<Object>				Bitmap cache form
	boundsCache	<Rectangle>		Bounds of the element
	layout	<MOLayout>				Layout associated to the element
	popup	<Canvas>					Reference a canvas. This is used for removing the popup. This is fairly ugly, it has to be removed
	nodes	<SequenceableCollection>	List of contained nodes
	absoluteBoundsCache	<Rectangle>	Absolute bounds cache
	elementsToDisplayCache	<(SequenceableCollection of: MOGraphElement)>	Cache for the elements to display, which are not rendered by the bitmap form cache
	attributes	<IdentityDictionary>	Attributes that can be attached to a node
	elementsToLookup	<ProtoObject>	List of elements to lookup. This is different than elementsToDisplayCache because it 
	zOrder	<ProtoObject> 			zOrder of the element
	lookupNodeCache	<Dictionary>	Cache used when looking up edges!

MOGraphElement subclass: #MOEdge
	instanceVariableNames: 'source target cacheFromPoint cacheToPoint isVisible'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

!MOEdge classSide methodsFor: 'default' stamp: 'jannik.laval 7/13/2010 16:46'!
defaultLineShapeClass 
	^ MOShape defaultLineShapeClass! !

!MOEdge classSide methodsFor: 'instance creation' stamp: 'tg 4/23/2008 20:10'!
from: aNode to: anotherNode

	^self new
		source: aNode;
		target: anotherNode;
		yourself! !

!MOEdge methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 9/14/2010 10:22'!
bounds
	^ boundsCache ifNil: [ boundsCache := self shape computeBoundsFor: self ].
! !

!MOEdge methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2010 21:29'!
cacheFromPoint
	"Return the extremity point"
	^ cacheFromPoint! !

!MOEdge methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2010 21:29'!
cacheFromPoint: anObject
	"Set the extremity point"
	cacheFromPoint := anObject! !

!MOEdge methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2010 21:29'!
cacheToPoint
	"Return the extremity point"
	^ cacheToPoint! !

!MOEdge methodsFor: 'accessing' stamp: 'AlexandreBergel 12/23/2010 21:29'!
cacheToPoint: anObject
	"Set the extremity point"
	cacheToPoint := anObject! !

!MOEdge methodsFor: 'displaying' stamp: 'SantiagoVidal 5/18/2011 09:09'!
displayWithoutCacheOn: aCanvas 
	"shape display: self on: aCanvas."
	shape acceptVisitor: ( ConcreteShapeVisitor newElement: self on:aCanvas ).! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 12:15'!
fromPositions
	^ shape fromPositions! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 12:15'!
fromPositions: collection
	shape fromPositions: collection! !

!MOEdge methodsFor: 'initialization' stamp: 'AlexandreBergel 12/29/2010 12:51'!
initialize 
	super initialize.
	shape := MOShape defaultLineShapeInstance.
	isVisible := true! !

!MOEdge methodsFor: 'testing cache' stamp: 'Alexandre Bergel 7/17/2010 08:26'!
isCacheLoaded
	^ cacheFromPoint notNil and: [ cacheToPoint notNil ]! !

!MOEdge methodsFor: 'testing' stamp: 'AlexandreBergel 2/16/2011 19:21'!
isEdge
	^ true! !

!MOEdge methodsFor: 'accessing' stamp: 'AlexandreBergel 12/29/2010 12:51'!
isVisible
	^ isVisible! !

!MOEdge methodsFor: 'accessing' stamp: 'AlexandreBergel 12/29/2010 12:51'!
isVisible: boolean
	isVisible := boolean! !

!MOEdge methodsFor: 'testing' stamp: 'AlexandreBergel 1/10/2011 10:00'!
isVisibleInBounds: bounds
	"Return true if the element is visible within the bounds, absolute bounds are tested for this"

	^ self absoluteBounds intersects: bounds! !

!MOEdge methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 3/15/2010 16:18'!
length
	^ (self target position - self source position) r! !

!MOEdge methodsFor: 'actions' stamp: 'Alexandre Bergel 3/2/2010 12:49'!
remove
	^ self owner removeEdge: self! !

!MOEdge methodsFor: 'cache' stamp: 'AlexandreBergel 1/10/2011 11:26'!
resetCache
	cacheFromPoint := nil.
	cacheToPoint := nil.
	boundsCache := absoluteBoundsCache := nil.! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 6/6/2009 13:14'!
setIfNilFromPositions: symbols
	self fromPositions ifNil: [ self fromPositions: symbols ]! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 6/6/2009 13:14'!
setIfNilToPositions: symbols
	self toPositions ifNil: [ self toPositions: symbols ]! !

!MOEdge methodsFor: 'accessing' stamp: 'tg 4/23/2008 20:09'!
source
	^ source! !

!MOEdge methodsFor: 'accessing' stamp: 'tg 4/23/2008 20:09'!
source: anObject
	source := anObject! !

!MOEdge methodsFor: 'accessing' stamp: 'tg 4/23/2008 20:09'!
target
	^ target! !

!MOEdge methodsFor: 'accessing' stamp: 'tg 4/23/2008 20:09'!
target: anObject
	target := anObject! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 12:15'!
toPositions
	^ shape toPositions! !

!MOEdge methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/12/2009 12:15'!
toPositions: collection
	shape toPositions: collection! !

!MOEdge methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 7/15/2010 14:50'!
zOrder
	^ zOrder ifNil: [ zOrder := (self source zOrder max: self target zOrder) - 1].
	
! !

!MOGraphElement classSide methodsFor: 'instance-creation' stamp: 'lr 11/6/2006 08:29'!
on: anObject
	^ self new setModel: anObject! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 1/24/2010 14:33'!
absoluteBounds
	"Answer the bounds in absolute terms (relative to the entire Canvas, not just the parent)."
	absoluteBoundsCache ifNotNil: [ ^ absoluteBoundsCache ].
	^ absoluteBoundsCache := self shape absoluteBoundsFor: self! !

!MOGraphElement methodsFor: 'actions' stamp: 'AlexandreBergel 12/4/2011 10:56'!
adoptNewShape: aShape
	"This method should be used to change the shape of myself.
	This method takes care of updating the cache"

	| oldShape |
	oldShape := self shape.
	self shape: aShape.
! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 12/20/2009 12:03'!
allNodes
	| coll |
	coll := OrderedCollection new.
	self allNodesDo: [:n | coll add: n].
	^ coll! !

!MOGraphElement methodsFor: 'enumerating' stamp: 'AlexandreBergel 12/30/2010 16:07'!
allNodesDo: aBlock
	"Evaluate aBlock all its children."
	
	self copy nodesDo: [ :each |
		aBlock value: each.
		each allNodesDo: aBlock ]! !

!MOGraphElement methodsFor: 'announce' stamp: 'Alexandre Bergel 12/17/2009 19:22'!
announce: anAnnouncement
	"public method"
	announcer ifNil: [ ^ self ].
	anAnnouncement element: self.
	announcer announce: anAnnouncement
! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 3/8/2009 21:21'!
announcer
	"Answer the announcer of the receiver."
	
	^ announcer ifNil: [ announcer := MOAnnouncer new ]! !

!MOGraphElement methodsFor: 'attributes' stamp: 'Alexandre Bergel 3/15/2010 15:41'!
attributeAt: aSymbol

	^ self attributes at: aSymbol! !

!MOGraphElement methodsFor: 'attributes' stamp: 'AlexandreBergel 9/16/2010 01:44'!
attributeAt: aSymbol ifAbsent: aBlock

	^ self attributes at: aSymbol ifAbsent: aBlock! !

!MOGraphElement methodsFor: 'attributes' stamp: 'AlexandreBergel 9/16/2010 01:45'!
attributeAt: aSymbol ifAbsentPut: aBlock

	^ self attributes at: aSymbol ifAbsentPut: aBlock! !

!MOGraphElement methodsFor: 'attributes' stamp: 'Alexandre Bergel 3/15/2010 14:27'!
attributeAt: aSymbol put: aValue
	^ self attributes at: aSymbol put: aValue! !

!MOGraphElement methodsFor: 'attributes' stamp: 'AlexandreBergel 11/29/2010 12:43'!
attributeKeysMatching: regexp
	^ self attributes keys select: [:k | regexp match: k]! !

!MOGraphElement methodsFor: 'attributes' stamp: 'Alexandre Bergel 3/15/2010 14:19'!
attributes
	^ attributes ifNil: [ attributes := IdentityDictionary new ]! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 4/30/2011 10:40'!
bounds
	"Answer the relative bounds of the receiver."

	| basicBounds |

	boundsCache ifNotNil: [ ^ boundsCache ].

	"We check if  the shape if present"
	self shapeBoundsAt: self shape ifPresent: [ :b | ^ boundsCache := b ].

	basicBounds := self shape computeBoundsFor: self.
	self shapeBoundsAt: self shape put: basicBounds.
	^ boundsCache := basicBounds! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 4/11/2011 16:57'!
cache
	^ cache ifNil: [ cache := Dictionary new ]! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 4/11/2011 17:19'!
cacheNamed: aSymbol of: aShape
	(self cache associationsDo: [ :ass | (ass key symbol == aSymbol and: [ ass key shape == aShape ]) ifTrue: [ ^ ass value ] ]).
	self error: 'Cache not found' ! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 4/11/2011 17:33'!
cacheNamed: aSymbol of: aShape ifAbsentInitializeWith: aBlock
	"aSymbol should start with #cache, else it will not be properly reseted"
	^ self shape isCached
		ifTrue: [ self cache at: (MOElementShapeProperties shape: aShape key: aSymbol)  ifAbsentPut: [ aBlock value] ]
		ifFalse: [ aBlock value ]! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 4/11/2011 17:33'!
cacheNamed: aSymbol of: aShape put:  aValue
	"aSymbol should start with #cache, else it will not be properly reseted"
	self cache at: (MOElementShapeProperties shape: aShape key: aSymbol) put: aValue! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 4/30/2011 10:41'!
center
	"Answer the center of the graphical element"

	^ self bounds center copy! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'TudorGirba 5/26/2012 22:57'!
collectPathToRootIn: aCollection
	"Return the path from this graph to the root graph"

	aCollection addLast: self.
	self owner ifNotNil: [self owner collectPathToRootIn: aCollection]! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre.Bergel 9/25/2009 20:57'!
copyShapeAndDo: aOneArgumentBlock
	"Copy the shape of the receiver and evaluates the block with the copy as argument"
	self copyShapeWithoutUpdatingAndDo: aOneArgumentBlock.
	self root updateWindow! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre.Bergel 9/25/2009 20:57'!
copyShapeWithoutUpdatingAndDo: aOneArgumentBlock
	"Copy the shape of the receiver and evaluates the block with the copy as argument"
	| newShape |
	newShape := self shape copy.
	aOneArgumentBlock value: newShape.
	self adoptNewShape: newShape! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/2/2009 15:43'!
corner
	"Alexandre Bergel, Feb 2, 2009: copied from Visual works"
	
	^self bounds corner
! !

!MOGraphElement methodsFor: 'initialization' stamp: 'Alexandre Bergel 10/15/2009 20:06'!
defaultNodeShapeClass
	^ MONode defaultNodeShapeClass! !

!MOGraphElement methodsFor: 'actions' stamp: 'AlexandreBergel 1/27/2011 09:28'!
deselect
	isSelected := false.
	self root deselect: self.
	! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 2/2/2009 15:44'!
diameter
	^2 * self radius! !

!MOGraphElement methodsFor: 'displaying' stamp: 'AlexandreBergel 4/9/2011 15:56'!
displayWithoutCacheOn: aCanvas
	self subclassResponsibility ! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 4/2/2010 19:00'!
domain
	^ self root nodes collect: [ :each | each model ]! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 2/21/2009 14:02'!
extent
	^ shape extentFor: self! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'jannik.laval 4/14/2009 14:14'!
firstSubnodeThat: aBlock
	^ self firstSubnodeThat: aBlock ifAbsent: [nil]! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 12/7/2009 23:08'!
firstSubnodeThat: aBlock ifAbsent: aBlock2
	self allNodesDo: [:node | (aBlock value: node) ifTrue: [ ^ node]].
	^ aBlock2 value! !

!MOGraphElement methodsFor: 'attributes' stamp: 'Alexandre Bergel 3/15/2010 14:26'!
hasAttribute: aSymbol
	attributes ifNil: [ ^ false ].
	^ self attributes includesKey: aSymbol! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 4/11/2011 17:09'!
hasCache: elementShapeProperty
	"aSymbol should start with #cache, else it will not be properly reseted"
	^ self cache includesKey: elementShapeProperty! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 4/11/2011 17:32'!
hasCacheNamed: symbol of: aShape

	(self cache associationsDo: [ :ass | (ass key symbol == symbol and: [ ass key shape == aShape ]) ifTrue: [ ^ true ] ]).
	^ false! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 8/30/2009 13:42'!
hasInteraction
	^ announcer notNil! !

!MOGraphElement methodsFor: 'initialization' stamp: 'Alexandre Bergel 10/15/2009 20:09'!
initialize
	self resetCache.
	isSelected := false.
	! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 3/31/2009 21:15'!
interaction
	^ self announcer! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/21/2009 14:44'!
interaction: anAnnouncer
	announcer := anAnnouncer! !

!MOGraphElement methodsFor: 'testing' stamp: 'AlexandreBergel 2/16/2011 19:21'!
isEdge
	^ false! !

!MOGraphElement methodsFor: 'testing' stamp: 'AlexandreBergel 2/16/2011 19:21'!
isNode
	^ false! !

!MOGraphElement methodsFor: 'testing' stamp: 'Alexandre Bergel 7/26/2010 12:22'!
isNotRoot
	^ self isRoot not! !

!MOGraphElement methodsFor: 'testing' stamp: 'jannik.laval 5/15/2009 13:43'!
isRoot
	^ false! !

!MOGraphElement methodsFor: 'testing' stamp: 'AlexandreBergel 1/10/2011 00:00'!
isVisibleInBounds: bounds
	"Return true if the element is visible within the bounds, absolute bounds are tested for this"
	
	self subclassResponsibility! !

!MOGraphElement methodsFor: 'accessing' stamp: 'lr 11/9/2006 21:57'!
layout
	"Answer the layout of the receiver."
	
	^ layout! !

!MOGraphElement methodsFor: 'accessing' stamp: 'lr 11/9/2006 22:03'!
layout: aLayout
	layout := aLayout! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 4/11/2011 17:00'!
metricCaches
	^ self cache keys! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'lr 9/20/2006 16:33'!
model
	"Answer the underlying model of this element."
	
	^ model! !

!MOGraphElement methodsFor: 'initialization' stamp: 'tg 4/23/2008 21:37'!
model: anObject
	model := anObject! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'TudorGirba 5/26/2012 22:52'!
mostSpecificParentCommonWith: anotherNode
	"Search the smallest possible element that is parent of self and of anotherNode"

	|  anotherPathToRoot | 
	anotherPathToRoot := anotherNode pathToRoot.

	self pathToRoot do: [ :eachElement | 
		(anotherPathToRoot includes: eachElement)
			ifTrue: [ ^ eachElement ] ]! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 4/2/2010 19:00'!
nodeForDomainValue: anObject
	"Returns the MONode corresponding to the value anObject"
	
	^ self withAllSubnodes detect: [ :each | each model = anObject]! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 4/2/2010 19:00'!
nodeForDomainValue: anObject ifAbsent: aBlock
	"Returns the MONode corresponding to the value anObject"
	
	^ self allNodes detect: [ :each | each model = anObject] ifNone: aBlock! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 4/2/2010 19:00'!
nodeForDomainValues: aCollection
	"Returns the MONode corresponding to the values contained in aCollection"
	| result |
	aCollection isCollection
		ifFalse: [ ^ self nodeForDomainValues: {aCollection} ].
	result := aCollection collect: [:val | self nodeForDomainValue: val ifAbsent: [nil]].
	^ result copyWithout: nil! !

!MOGraphElement methodsFor: 'attributes' stamp: 'AlexandreBergel 11/29/2010 12:51'!
numberOfCacheKeys
	^ self attributes keys size! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 11/29/2010 16:13'!
numberOfCachedMetrics
	^ self metricCaches size! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/30/2009 14:13'!
origin
	"return a relative origin (position of myself from my parent)"
	^self bounds origin! !

!MOGraphElement methodsFor: 'printing' stamp: 'Alexandre Bergel 7/19/2010 10:51'!
originalPrintOn: aStream
	super printOn: aStream! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'lr 11/3/2006 17:33'!
owner
	"Answer the owning element of this element, or nil if this is the root."
	
	^ owner! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'TudorGirba 5/26/2012 23:16'!
pathToRoot
	"Return the path from this graph to the root graph"

	| path |
	path := OrderedCollection new.
	self owner ifNotNil: [self owner collectPathToRootIn: path].
	^path! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/1/2009 15:17'!
popup
	^ popup! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/1/2009 15:17'!
popup: anObject
	popup := anObject! !

!MOGraphElement methodsFor: 'printing' stamp: 'Alexandre Bergel 7/19/2010 10:51'!
printOn: aStream
	self originalPrintOn: aStream.
	aStream nextPutAll: ' model: '; print: self model! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 2/17/2009 17:32'!
radius
	^(self origin dist: self corner) / 2! !

!MOGraphElement methodsFor: 'actions' stamp: 'AlexandreBergel 12/30/2010 16:08'!
remove
	"Remove the receiver from the parent element."
	
	owner ifNil: [ ^ self ].
	owner removeNode: self! !

!MOGraphElement methodsFor: 'actions' stamp: 'AlexandreBergel 5/18/2011 15:45'!
removeAllNodes
! !

!MOGraphElement methodsFor: 'attributes' stamp: 'Alexandre Bergel 3/15/2010 14:28'!
removeAttribute: aSymbol
	self attributes removeKey: aSymbol! !

!MOGraphElement methodsFor: 'attributes' stamp: 'AlexandreBergel 12/2/2010 10:59'!
removeAttributesMatching: regexp
	self attributes keys copy do: [ :k |
		(regexp match: k asString)
			ifTrue: [ self attributes removeKey: k ifAbsent: [].
					"This help getting through concurent accesses"] ]! !

!MOGraphElement methodsFor: 'actions' stamp: 'Alexandre Bergel 2/25/2010 18:36'!
removePopupIfExist
	self popup ifNotNilDo: [:v | v delete].
	self popup: nil! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 5/18/2011 15:07'!
resetCache
	self subclassResponsibility! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 1/26/2010 22:39'!
resetElementsToDisplayCacheRecursively
	self withAllNodesDo: #resetElementsToDisplayCache! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 4/11/2011 17:26'!
resetMetricCaches
	cache := nil.! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 4/15/2012 21:18'!
resetMetricCachesRecursively
! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 9/1/2010 19:13'!
resetMetricCachesUpToTheRoot
	self resetMetricCaches.
	self owner resetMetricCachesUpToTheRoot
! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'tg 4/25/2008 09:58'!
root
	"Answer the root node of this graph element, by recursively walking upwards the owner nodes."
	^ owner root! !

!MOGraphElement methodsFor: 'actions' stamp: 'AlexandreBergel 1/27/2011 09:25'!
select
	"Select the element. A selection box will surround the node"

	isSelected := true.
	self root addSelection: self.
! !

!MOGraphElement methodsFor: 'initialization' stamp: 'lr 11/3/2006 17:31'!
setAnnouncer: anAnnouncer
	announcer := anAnnouncer! !

!MOGraphElement methodsFor: 'initialization' stamp: 'lr 11/3/2006 17:31'!
setModel: anObject
	model := anObject! !

!MOGraphElement methodsFor: 'initialization' stamp: 'lr 9/18/2006 10:50'!
setOwner: aFigure
	owner := aFigure! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre Bergel 1/11/2010 10:08'!
shape
	"Each element has a shape to graphically render itself"
	
	^ shape! !

!MOGraphElement methodsFor: 'accessing' stamp: 'Alexandre Bergel 12/28/2009 12:58'!
shape: aShape 
	"This method does not update the cache. Use adoptNewShape: if you wish to do so"
	shape := aShape.
! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'simon.denier 3/5/2009 11:16'!
shapeBounds
	^ cacheShapeBounds! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre.Bergel 8/18/2009 21:58'!
shapeBoundsAt: aShape
	^ self shapeBounds at: aShape! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 12/23/2010 21:19'!
shapeBoundsAt: aShape ifAbsent: aBlock
	^ self shapeBounds at: aShape ifAbsent: aBlock.! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 4/6/2011 19:09'!
shapeBoundsAt: aShape ifAbsentPut: aBlock
	| v |
	v := self shapeBounds at: aShape ifAbsentPut: aBlock.
	self assert: [ (self shapeBounds at: aShape ) isRectangle ].
	^ v ! !

!MOGraphElement methodsFor: 'cache' stamp: 'Alexandre Bergel 8/9/2010 18:39'!
shapeBoundsAt: aShape ifPresent: aBlock

	self shapeBounds ifNil: [ ^ self ].
	^ self shapeBounds at: aShape ifPresent: aBlock! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 4/6/2011 19:09'!
shapeBoundsAt: aShape put: bounds
	self assert: [ bounds isRectangle ].
	cacheShapeBounds ifNil: [ cacheShapeBounds := SmallDictionary new ].
	 
	boundsCache := absoluteBoundsCache := nil.
	self shapeBounds at: aShape put: bounds.
! !

!MOGraphElement methodsFor: 'displaying' stamp: 'Alexandre.Bergel 4/23/2009 16:07'!
threadholdSize
	"If the width or the heigh is below this size, then nested nodes and edges are not displayed"
	^ 4! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 2/28/2010 23:48'!
totalNumberOfNodes
	^ self withAllSubnodes size! !

!MOGraphElement methodsFor: 'cache' stamp: 'AlexandreBergel 4/6/2011 17:59'!
translateAbsoluteCacheBy: aPoint
	"This method is ugly. It should not be. A cache is not made to be directly manipulated"
	absoluteBoundsCache ifNil: [ ^ self ].
	absoluteBoundsCache := absoluteBoundsCache translateBy: aPoint! !

!MOGraphElement methodsFor: 'translation and bounds' stamp: 'Alexandre Bergel 4/26/2010 10:17'!
updateBounds
! !

!MOGraphElement methodsFor: 'enumerating' stamp: 'Alexandre Bergel 12/7/2009 23:09'!
withAllNodesDo: aBlock
	"Evaluate aBlock with the receiver and all its nodes."
	
	aBlock value: self.
	self allNodesDo: aBlock! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 12/20/2009 12:02'!
withAllSubnodes
	^ self allNodes, {self}! !

!MOGraphElement methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 1/26/2010 21:51'!
zOrder
	self subclassResponsibility! !

MOGraphElement subclass: #MONode
	instanceVariableNames: 'incomingEdges outgoingEdges nodes edges cacheForm lookupNodeCache elementsToDisplayCache elementsToLookup'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

!MONode commentStamp: '<historical>' prior: 0!
A MONode is an elementary element of a visualization. Nodes may be nested and linked to other nodes. In the large majority of cases, a shape is shared among several nodes.
MONode is an essential class.

Instance Variables
	cacheForm:		<Object>
	edges:		<Object>
	elementsToDisplayCache:		<Object>
	elementsToLookup:		<Object>
	incomingEdges:		<Object>
	lookupNodeCache:		<Object>
	nodes:		<Object>
	outgoingEdges:		<Object>

cacheForm
	- contains the bitmap cache. The cache is activated after the first drawing of it. 

edges
	- the list of edges nested by the node. Note that it is not necessary that the edges start or end from the node that contains them. 

elementsToDisplayCache
	- because of the zOrder,  this variable contains a sorted collection of the elements to display.

elementsToLookup
	- cache used when defining the edges.

incomingEdges
	- list of incoming edges

lookupNodeCache
	- xxxxx

nodes
	- nested nodes

outgoingEdges
	- list of outgoing edges
!

!MONode classSide methodsFor: 'default' stamp: 'jannik.laval 7/13/2010 16:41'!
defaultNodeShapeClass 
	^ MOShape defaultNodeShapeClass
! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 5/18/2011 11:30'!
addEdge: anEdge 
	"Add anEdge to the children edges of the receiver."
	anEdge target addIncomingEdge: anEdge.
	anEdge source addOutgoingEdge: anEdge.
	self edges add: (anEdge setOwner: self)! !

!MONode methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/25/2009 22:04'!
addIncomingEdge: anEdge
	incomingEdges ifNil: [ incomingEdges := OrderedCollection new ].
	incomingEdges add: anEdge! !

!MONode methodsFor: 'accessing' stamp: 'AlexandreBergel 12/30/2010 16:00'!
addNode: aNode 
	"Add anElement to the children of the receiver."
	
	nodes ifNil: [ nodes := OrderedCollection new ].
	nodes add: (aNode setOwner: self)! !

!MONode methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/26/2009 10:11'!
addOutgoingEdge: anEdge
	outgoingEdges ifNil: [ outgoingEdges := OrderedCollection new ].
	outgoingEdges add: anEdge! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 12/4/2011 10:56'!
adoptNewShape: aShape
	"This method should be used to change the shape of myself.
	This method takes care of updating the cache"

	| oldShape |
	oldShape := self shape.
	self shape: aShape.
	(self shapeBoundsAt: oldShape ifAbsent: [nil])
		ifNotNil:  
			[self shapeBoundsAt: aShape put: (self shapeBoundsAt: oldShape ifAbsentPut: [ aShape ])]! !

!MONode methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 5/18/2011 15:46'!
allEdges
	"return the recursively computed outgoing edges"
	| coll |
	coll := OrderedCollection new.
	coll addAll: self edges.
	self allNodesDo: [:n | coll addAll: n edges].
	^ coll! !

!MONode methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 5/18/2011 15:53'!
allEdgesConnectedTo: aNode
	^ self allEdges select: [:edge | edge source == aNode or: [ edge target == aNode ]]! !

!MONode methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 1/12/2010 14:52'!
allEdgesConnectedToMe
	^ self root allEdgesConnectedTo: self! !

!MONode methodsFor: 'enumerating' stamp: 'AlexandreBergel 5/18/2011 15:45'!
allEdgesDo: aBlock
	"Evaluate aBlock all its edges."
	
	self edges copy do: [ :edge | aBlock value: edge ].
	self allNodesDo: [ :each |
		each allEdgesDo: aBlock ]
! !

!MONode methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 12/14/2011 10:55'!
allIncomingEdges
	"Return the list of incoming edges"

	| coll |
	coll := OrderedCollection new.
	self withAllNodesDo: [:n | coll addAll: n incomingEdges].
	^ coll! !

!MONode methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 12/14/2011 11:00'!
allOutcomingEdges
	"Return the list of outgoing edges. "

	| coll |
	coll := OrderedCollection new.
	self withAllNodesDo: [:n | coll addAll: n outgoingEdges].
	^ coll! !

!MONode methodsFor: 'querying' stamp: 'AlexandreBergel 12/30/2010 18:52'!
allSelectedNodes
	^ self elementsToLookup select: #isSelected! !

!MONode methodsFor: 'layouting' stamp: 'AlexandreBergel 4/15/2012 21:18'!
applyLayout
	"Layout the receiver and all its children."

	| b |
	self resetMetricCachesRecursively.
	b := self hasNode
		ifTrue: [ 0 @ 0 extent: 0 @ 0 ]
		ifFalse: [ self shape computeBoundsFor: self ].

	self shapeBoundsAt: self shape put: b.	"if the node has sub nodes, then we need to apply the layout, else, we do nothing"
		
	self hasNode
		ifTrue: [ 
			self nodesDo: [ :each | each applyLayout ].
			self layout applyOn: self ].	"nodes have been located properly. Now, we need to update the size of me (i.e., the size of my shape)"	
				
	"apply:bounds: does a side effect on b"
	shape updateBounds: self for: b.
	
	"Special treatment with forms shape"
	shape isFormsShape
		ifTrue: [ self shapeBoundsAt: self shape put: (self shape computeBoundsFor: self) ] ! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 12/14/2011 11:00'!
cacheCanvas: aCanvas
	"Load the cache with what is given as argument"
	
	cacheForm := aCanvas form copy: ((self bounds origin + aCanvas origin - (1@1)) 
													extent: (self bounds extent + (2@2))).! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 12/14/2011 11:00'!
cacheForm
	"Return the cache. This method is essentially used in the test"
	
	^ cacheForm! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 12/14/2011 11:01'!
clear
	"Set to nil the nodes and edges"

	nodes := nil.
	edges := nil.
	lookupNodeCache := nil! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 12/16/2010 16:46'!
clearLookupCacheRecursively
	lookupNodeCache := nil.
	owner clearLookupCacheRecursively! !

!MONode methodsFor: 'displaying' stamp: 'AlexandreBergel 5/18/2011 15:53'!
computeElementsToDisplay

	| sorted |
	sorted := SortedCollection sortBlock: [:a :b | a zOrder <= b zOrder].
	self allNodesDo: [:e | sorted add: e].
	self allEdgesDo: [:e | sorted add: e].
	^ sorted asOrderedCollection.! !

!MONode methodsFor: 'actions' stamp: 'Alexandre Bergel 4/25/2010 11:54'!
decreaseZoom

	self decreaseZoomBy: 0.9! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 4/15/2012 21:17'!
decreaseZoomBy: aValue
	self scaleBy: aValue.
	self nodes do: [:node | node decreaseZoomBy: aValue ].
	self resetFormCacheRecursively.! !

!MONode methodsFor: 'layouting' stamp: 'AlexandreBergel 5/18/2011 15:46'!
deepApplyLayout
	self nodes do: [:each | each deepApplyLayout].
	self applyLayout.! !

!MONode methodsFor: 'querying' stamp: 'AlexandreBergel 12/30/2010 18:52'!
deepFindNodeWithEntity: anObject
	^ self firstSubnodeThat: [:each | each model = anObject]! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 1/27/2011 09:28'!
deselect
	"Deselect the element"
	
	self resetFormCacheUpToTheRoot.
	self resetFormCache.
	^ super deselect! !

!MONode methodsFor: 'displaying' stamp: 'AlexandreBergel 7/7/2011 11:48'!
displayCacheOn: aCanvas 
	"Display the cache form on the provided canvas. No translation has been realized on it "

	aCanvas paintImage: self cacheForm at: (self absoluteBounds origin - (1@1)).! !

!MONode methodsFor: 'displaying' stamp: 'AlexandreBergel 7/7/2011 12:17'!
displayWithoutCacheOn: aCanvas 
	"a Node is displayed at the coordinate given by its _absolute_ position. The relative position
	 cannot be used because of the zOrder. An outter node may not be necessarily be displayed before 
	 its inner nodes"

	"We should not cache"
	aCanvas 
		translateBy: self absoluteBounds origin
		during: [:tmpCanvas | shape acceptVisitor: (ConcreteShapeVisitor newElement: self on: tmpCanvas ). ].
	
	"We display the subnodes"
	self elementsToDisplay do: [ :each | each displayWithoutCacheOn: aCanvas ]
	! !

!MONode methodsFor: 'accessing' stamp: 'AlexandreBergel 4/30/2011 10:47'!
edges
	"Answer the edges that are contained in myself. Note that the extremity of each edges may not necessarily be contained in myself."

	^edges ifNil: [ edges := OrderedCollection new ]! !

!MONode methodsFor: 'enumerating' stamp: 'AlexandreBergel 12/30/2010 18:01'!
edgesDo: aBlock
	"Iterates over all the edges of the receiver."
	
	edges ifNil: [ ^ self ].
	edges do: aBlock
! !

!MONode methodsFor: 'querying' stamp: 'AlexandreBergel 12/30/2010 18:42'!
elementAt: aPoint
	^ self elementAt: aPoint ifAbsent: [ self root ]! !

!MONode methodsFor: 'querying' stamp: 'AlexandreBergel 12/30/2010 18:43'!
elementAt: aPoint ifAbsent: aBlock
	"Answer the element at aPoint or evaluate aBlock if none. Note that this implementation assumes that children are always fully contained within their owner and is therefore very efficient."
	"aPoint is relative coordinate."

	"we do not call elementsToDisplay since its content may have been modified because of the cache"
	^ self elementsToLookup reverse 
			detect: [ :element | element shape containsPoint: aPoint for: element ] 
			ifNone: aBlock.
! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 12/30/2010 18:26'!
elementsToDisplay

	elementsToDisplayCache ifNotNil: [ ^ elementsToDisplayCache ].
	^ elementsToDisplayCache := self computeElementsToDisplay! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 12/30/2010 18:41'!
elementsToLookup
	"This method is used by elementAt:"

	elementsToLookup ifNotNil: [ ^ elementsToLookup ].
	^ elementsToLookup := self computeElementsToDisplay! !

!MONode methodsFor: 'accessing-readonly' stamp: 'tg 10/5/2008 19:43'!
endPoint
	^self bounds topCenter! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 6/19/2011 13:39'!
expandToIncludePoint: aPoint
	"Expand the bounds of myself"

	| bounds |
	bounds := self bounds.
	bounds width: ((bounds width max: aPoint x)) asInteger.
	bounds height: ((bounds height max: aPoint y)) asInteger.
! !

!MONode methodsFor: 'accessing-readonly' stamp: 'TudorGirba 5/26/2012 23:21'!
externalEdges
	| tmpNodes |
	tmpNodes := self allNodes.
	^ tmpNodes flatCollect: [ :node |
		(node outgoingEdges reject: [ :edge | edge target owner == node owner ]) ,
		(node incomingEdges reject: [ :edge | edge source owner == node owner ]) ] ! !

!MONode methodsFor: 'translation and bounds' stamp: 'Alexandre Bergel 4/25/2010 11:49'!
getBoundedTranslationStep: wantedStepAsPoint
	"Return the real translation step when the translation is bounded"
	"We do not let the position to be outside of the parent"

	| newRelativePosition |
	^ owner isRoot not 
		ifTrue: [
			newRelativePosition := self origin + wantedStepAsPoint.
			newRelativePosition := newRelativePosition adhereTo: 
									(0@0 rect: (owner bounds extent - self bounds extent)).
			newRelativePosition - self bounds origin ]
		ifFalse: [
			wantedStepAsPoint ]
! !

!MONode methodsFor: 'translation and bounds' stamp: 'AlexandreBergel 6/19/2011 13:31'!
getTranslationStep: aPoint bounded: bounded
	^ bounded
		ifTrue: [ self getBoundedTranslationStep: aPoint ]
		ifFalse: [ aPoint ]! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 12/30/2010 18:10'!
hasCachedForm
	^ cacheForm notNil! !

!MONode methodsFor: 'testing' stamp: 'Alexandre.Bergel 9/25/2009 22:05'!
hasIncomingEdges
	incomingEdges ifNil: [ ^ false ].
	^ self incomingEdges notNil! !

!MONode methodsFor: 'testing' stamp: 'AlexandreBergel 12/30/2010 15:59'!
hasNode
	^(nodes isNil or: [nodes isEmpty]) not! !

!MONode methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 12/14/2011 11:01'!
height
	"Return the height of a node"
	
	^self bounds height! !

!MONode methodsFor: 'enumerating' stamp: 'AlexandreBergel 1/20/2011 10:29'!
incomingAndOutgoingEdgesDo: oneArgBlock
	"Iterate over all the incoming and outgoing edges of myself"

	self incomingEdges do: oneArgBlock.
	self outgoingEdges do: oneArgBlock.! !

!MONode methodsFor: 'accessing' stamp: 'AlexandreBergel 4/30/2011 10:49'!
incomingEdges
	"Answer the list of incoming edges to myself"

	incomingEdges ifNil: [ ^ #() ].
	^ incomingEdges! !

!MONode methodsFor: 'actions' stamp: 'Alexandre Bergel 4/25/2010 11:54'!
increaseZoom

	self increaseZoomBy: 1.1! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 4/15/2012 21:17'!
increaseZoomBy: aValue
	self scaleBy: aValue.
	self nodes do: [:node | node increaseZoomBy: aValue ].
	self resetFormCacheRecursively.! !

!MONode methodsFor: 'initialization' stamp: 'Alexandre Bergel 6/17/2010 12:24'!
initialize 
	super initialize.
	shape := MOShape defaultNodeShapeInstance! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 12/30/2010 18:10'!
isCacheLoaded
	^  cacheForm isNil not! !

!MONode methodsFor: 'testing' stamp: 'AlexandreBergel 2/16/2011 19:24'!
isNode
	^ true! !

!MONode methodsFor: 'testing' stamp: 'AlexandreBergel 1/10/2011 00:02'!
isVisibleInBounds: bounds
	"Return true if the element is visible within the bounds, absolute bounds are tested for this"
	
	^ self absoluteBounds intersects: bounds! !

!MONode methodsFor: 'accessing' stamp: 'AlexandreBergel 4/30/2011 10:48'!
layout
	"Answer the layout. If none is defined, answer the default layout"

	^ layout ifNil: [ layout := MOHorizontalLineLayout new ]! !

!MONode methodsFor: 'querying' stamp: 'AlexandreBergel 12/30/2010 18:52'!
nodeWith: anObject
	^ self nodeWith: anObject ifAbsent: [ self error: 'not found' ] ! !

!MONode methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 12/30/2010 18:16'!
nodeWith: anObject ifAbsent: aBlock 
	"Not sure whether we should leave this method. Suspicious. AlexandreBergel 12/30/2010 18:16"
	
	| nodeLookedUp |
	lookupNodeCache ifNil: [ lookupNodeCache := IdentityDictionary new ].
	lookupNodeCache at: anObject ifPresent: [ :v | ^ v ].
	nodeLookedUp := self nodes detect: [:each | each model = anObject ] ifNone: aBlock.
	lookupNodeCache at: anObject put: nodeLookedUp.
	^ nodeLookedUp
! !

!MONode methodsFor: 'accessing' stamp: 'AlexandreBergel 4/30/2011 10:46'!
nodes
	"Answer the nodes that are directly contained by myself"
	
	^ nodes ifNil: [ #() ]! !

!MONode methodsFor: 'enumerating' stamp: 'AlexandreBergel 12/30/2010 15:57'!
nodesDo: aBlock
	"Iterates over all the subnodes of the receiver."
	
	nodes ifNil: [ ^ self ].
	nodes do: aBlock! !

!MONode methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 5/18/2011 15:47'!
numberOfNodes
	^ self nodes size! !

!MONode methodsFor: 'accessing' stamp: 'AlexandreBergel 4/30/2011 10:49'!
outgoingEdges
	"Answer the list of outgoing edges from myself"

	outgoingEdges ifNil: [ ^ #() ].
	^ outgoingEdges! !

!MONode methodsFor: 'actions' stamp: 'Alexandre Bergel 3/15/2010 15:01'!
position
	^ self bounds center
	! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 5/18/2011 15:54'!
removeAllEdges
	| root |
	root := self root.
	self allNodes do: [:n | (root allEdgesConnectedTo: n) do: #remove ].
	self allEdgesDo: #remove! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 5/18/2011 15:45'!
removeAllNodes
	"We cannot use nodesDo: here since the list is modified while being iterated over"
	self nodes copy do: #remove! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 5/18/2011 15:45'!
removeEdge: anEdge
	^ self edges remove: anEdge! !

!MONode methodsFor: 'displaying' stamp: 'AlexandreBergel 5/18/2011 15:45'!
removeElementToDisplay: element

	self elementsToDisplay remove: element ifAbsent: []! !

!MONode methodsFor: 'displaying' stamp: 'AlexandreBergel 5/18/2011 15:53'!
removeElementsToDisplay: elements
	elements do: [:el | self removeElementToDisplay: el ]
! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 12/30/2010 17:55'!
removeNode: anElement
	"Remove anElement from the children of the receiver."
	
	nodes ifNil: [ ^ self ].
	nodes remove: anElement ifAbsent: nil! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 12/30/2010 16:26'!
removeNodeWithValue: object
	"Does a side effect. Remove a the node corresponding to the object provided as argument"

	| node |
	node := self nodeForDomainValue: object.
	node incomingEdges do: [ :edge | self edges remove: edge ifAbsent: [] ].
	node outgoingEdges  do: [ :edge | self edges remove: edge ifAbsent: [] ].
	self nodes remove: node.! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 12/30/2010 16:28'!
removeNodesWithValue: objects
	objects do: [ :v | self removeNodeWithValue: v ]! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 1/10/2011 11:25'!
resetCache
	self resetElementsToLookup.
	boundsCache := absoluteBoundsCache := nil.	
		
	"Having IdentityDictionary instead of SmallDictionary works the same, it is faster although"
	cacheShapeBounds := SmallDictionary new.	"cacheShapeBounds := IdentityDictionary new"
	elementsToDisplayCache := nil.
	self resetMetricCaches! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 1/10/2011 11:26'!
resetCacheInEdges
	self edgesDo: [ :edge | edge resetCache ].
	self nodesDo: [ :node | node resetCacheInEdges ].
	
	self allIncomingEdges do: [ :edge | edge resetCache ].
	self allOutcomingEdges do: [ :edge | edge resetCache ].
! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 4/15/2012 21:17'!
resetCacheRecursively
	self resetCache.
	self nodesDo: [ :node | node resetCacheRecursively ].
	self edgesDo: [ :edge | edge resetCacheRecursively ].! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 12/30/2010 18:25'!
resetElementsToDisplayCache
	elementsToDisplayCache := nil! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 12/30/2010 18:41'!
resetElementsToLookup
	"This method is used by elementAt:"

	elementsToLookup := nil! !

!MONode methodsFor: 'displaying' stamp: 'AlexandreBergel 5/18/2011 11:28'!
resetElementsToLookupUpToTheRoot
	"This method is used by forNode: aBlockOrSymbol whenEnteringUpdateNode: enteringBlock whenLeavingUpdateNode: leavingBlock withLayoutUpdate: aBoolean. 
	It is related to elementAt:"
	self resetElementsToLookup.
	self owner ifNotNilDo: [:ow | ow resetElementsToLookupUpToTheRoot ]
! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 5/18/2011 15:47'!
resetFormCache
	self resetFormCacheSimply.
	
	owner resetElementsToDisplayCache 
! !

!MONode methodsFor: 'cache' stamp: 'BenComan 5/11/2012 00:25'!
resetFormCacheRecursively
	self resetFormCacheSimply.
	self nodes do: [:node | node resetFormCacheRecursively].
	
	"Currently, an edge cannot have inner nodes"
	"self edges do: [:edge | edge resetFormCacheRecursively]."! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 12/30/2010 18:10'!
resetFormCacheSimply
	cacheForm := nil.
! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 12/30/2010 18:25'!
resetFormCacheUpToTheRoot
	self resetFormCacheSimply.
	elementsToDisplayCache := nil.
	self owner resetFormCacheUpToTheRoot! !

!MONode methodsFor: 'cache' stamp: 'BenComan 5/11/2012 00:25'!
resetMetricCachesRecursively
	self resetMetricCaches.
	self nodesDo: #resetMetricCachesRecursively.
	self edgesDo: #resetMetricCaches! !

!MONode methodsFor: 'translation and bounds' stamp: 'AlexandreBergel 12/30/2010 13:10'!
scaleBy: aNumber 
	| keys |
	keys := self shapeBounds keys.
	keys do: [ :keyShape | 
		keyShape scaleElement: self by: aNumber.
	].
	boundsCache := absoluteBoundsCache := nil.
	
	self edgesDo: [:edge | edge resetCache].
	
	"The owner must update its bounds. It must scale as well"
	owner isRoot ifTrue: [owner updateBounds]! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 1/27/2011 09:25'!
select
	"Select the node"
	
	self resetFormCacheUpToTheRoot.
	self resetFormCache.
	^ super select! !

!MONode methodsFor: 'actions' stamp: 'AlexandreBergel 4/15/2012 21:17'!
setBoundsTo: newBounds
	"check if it is valid"
	| oldShapeBounds oldReferencialBounds deltaOrigin ratioW ratioH oldLocalBounds newLocalBounds |
	newBounds topLeft < newBounds bottomRight
		ifFalse: [ ^ self ].
	
	oldShapeBounds := self shapeBounds.
	self resetCache.
	"self shapeBounds at: self shape put: newBounds."
	
	oldReferencialBounds := oldShapeBounds at: self shape.
	deltaOrigin := newBounds topLeft - oldReferencialBounds topLeft.
	ratioW := newBounds width / oldReferencialBounds width.
	ratioH := newBounds height / oldReferencialBounds height.
	oldShapeBounds associationsDo:
		[:assoc | 
			oldLocalBounds := assoc value.
			newLocalBounds := Rectangle
							origin: (oldLocalBounds origin + deltaOrigin)
							width: (oldLocalBounds width * ratioW) asInteger
							height: (oldLocalBounds height * ratioH) asInteger.
			self shapeBoundsAt: assoc key put: newLocalBounds ].
	
	self resetFormCacheRecursively
	
! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 5/18/2011 15:07'!
setCacheForm: aCache

	cacheForm:= aCache.! !

!MONode methodsFor: 'testing cache' stamp: 'AlexandreBergel 12/30/2010 15:56'!
shouldCache
	"Answer whether or not the rendering of myself should be cached into a bitmap"
	
	^ nodes notNil and: [owner shouldCache not and: [self bounds area < 3000000]]
! !

!MONode methodsFor: 'translation and bounds' stamp: 'AlexandreBergel 1/10/2011 11:54'!
translateBy: aPoint
	^ self translateBy: aPoint bounded: false
	
"	owner isRoot  
		ifFalse: [ self translateBy: aPoint bounded: true ].
	^  self translateBy: aPoint bounded: false "! !

!MONode methodsFor: 'translation and bounds' stamp: 'AlexandreBergel 6/19/2011 13:44'!
translateBy: aPoint bounded: bounded
	"It moves the element by aPoint. 
	If bounded is true and the owner is not the root, 
	then the bounds are limited by the owner bounds.
	If the element is placed in the root, then the root's bounds are updated"

	| realStep newRelativePosition |
	self shapeBounds isNil
		ifTrue: [ ^ self bounds ].
	self shapeBounds isEmpty
		ifTrue: [ ^ self bounds ].

	realStep := self getTranslationStep: aPoint bounded: bounded.
	
	newRelativePosition := self origin + aPoint.
	self shapeBounds keys
		do: [ :eachShape | self shapeBoundsAt: eachShape put: ((self shapeBoundsAt: eachShape) translateBy: realStep) ].
	boundsCache := absoluteBoundsCache := nil.
	self allNodesDo: [ :n | n translateAbsoluteCacheBy: realStep ].
	
	"the root has to be extended in any case"
	owner isRoot
		ifTrue: [ 
			owner expandToIncludePoint: newRelativePosition + self bounds extent ].


	self resetCacheInEdges! !

!MONode methodsFor: 'translation and bounds' stamp: 'AlexandreBergel 12/14/2011 11:02'!
translateTo: aPoint 
	"Translate the node to a given point."

	self translateBy: (aPoint - self origin)! !

!MONode methodsFor: 'cache' stamp: 'AlexandreBergel 4/9/2011 15:20'!
updateOwner
	"This method is called after I have been cached into a bitmap.
	  I therefore have to tell to my owner to remove myself from the element to display since the bitmap will be displayed"
	
	"This method is used when the bitmap cache is set"
	| elems |
	elems := self elementsToDisplay.
	elems := elems copyWithoutAll: self externalEdges.
	owner removeElementsToDisplay: elems.! !

!MONode methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 12/14/2011 11:01'!
width
	"Return the width of a node"

	^self bounds width! !

!MONode methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 12/14/2011 11:02'!
zOrder
	"Give the zOrder of the node. This is used to order the node before displaying them"

	^ zOrder ifNil: [ zOrder := self owner zOrder + 2 ]! !

MONode subclass: #MORoot
	instanceVariableNames: 'selections cacheBounds canvas selectionBoxCorner1 selectionBoxCorner2 selectionBoxUsage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

!MORoot methodsFor: 'accessing-readonly' stamp: 'Alexandre.Bergel 4/10/2009 17:57'!
absoluteBounds
	"since a root does not have a owner/parent, and it has no shape, there is no point in looking up the 
	cacheShapeBounds"
	^ self bounds! !

!MORoot methodsFor: 'selection' stamp: 'AlexandreBergel 12/23/2010 20:37'!
addSelection: aGraphElement
	"An element is added to the list of selections when selected."

	selections add: aGraphElement! !

!MORoot methodsFor: 'layouting' stamp: 'AlexandreBergel 4/15/2012 21:18'!
applyLayout
	"Layout the receiver and all its children."

	self resetMetricCachesRecursively.
	self shapeBoundsAt: self shape put: (0@0 corner: 0@0).

	self nodesDo: [ :each |
		each applyLayout ].

	self layout applyOn: self.

	self nodesDo: [:each |
		self bounds corner: (self bounds corner max: (each extent + each origin)).
	].
! !

!MORoot methodsFor: 'accessing-readonly' stamp: 'AlexandreBergel 12/23/2010 21:07'!
bounds
	^ cacheBounds ifNil: [ cacheBounds := super bounds]
! !

!MORoot methodsFor: 'accessing' stamp: 'Alexandre Bergel 1/12/2010 14:31'!
canvas
	^ canvas! !

!MORoot methodsFor: 'accessing' stamp: 'Alexandre Bergel 1/12/2010 14:31'!
canvas: anObject
	canvas := anObject! !

!MORoot methodsFor: 'actions' stamp: 'AlexandreBergel 12/16/2010 16:46'!
clearLookupCacheRecursively
	lookupNodeCache := nil! !

!MORoot methodsFor: 'selection' stamp: 'tg 2/19/2010 18:27'!
deselect: aFigure
	selections remove: aFigure ifAbsent: []! !

!MORoot methodsFor: 'selection' stamp: 'AlexandreBergel 1/6/2011 10:33'!
deselectAll
	selections copy do: [:each | each deselect]! !

!MORoot methodsFor: 'displaying' stamp: 'AlexandreBergel 9/6/2010 09:24'!
displaySelectionBoxIfNecessaryOn: aCanvas

	self hasSelectionBox ifFalse: [ ^ self ].
	aCanvas 
		frameAndFillRectangle: ((Rectangle encompassing: {selectionBoxCorner1. selectionBoxCorner2} ))
		fillColor: Color lightBlue
		borderWidth: 2
		borderColor: Color blue! !

!MORoot methodsFor: 'actions' stamp: 'AlexandreBergel 6/27/2011 07:22'!
expandForEvent: ann
	self expandToIncludePoint: (ann position * 1.3) asIntegerPoint! !

!MORoot methodsFor: 'actions' stamp: 'AlexandreBergel 6/27/2011 07:34'!
expandToIncludePoint: aPoint
	"Expand the bounds of myself"

	super expandToIncludePoint: aPoint.
	canvas ifNotNil: [ canvas updateBounds ]! !

!MORoot methodsFor: 'selectionBox' stamp: 'AlexandreBergel 9/6/2010 10:00'!
hasSelectedNodes
	^ self allNodes anySatisfy: #isSelected ! !

!MORoot methodsFor: 'selection' stamp: 'tg 4/26/2008 00:52'!
hasSelection
	^selections notEmpty! !

!MORoot methodsFor: 'testing' stamp: 'AlexandreBergel 9/5/2010 17:55'!
hasSelectionBox
	^ selectionBoxCorner1 notNil & selectionBoxCorner2 notNil 
 
! !

!MORoot methodsFor: 'initialization' stamp: 'AlexandreBergel 9/5/2010 17:21'!
initialize
	super initialize.

	selections := OrderedCollection new.
	shape := self defaultNodeShapeClass new withoutBorder.

	selectionBoxCorner1 := nil.
	selectionBoxCorner2 := nil.
	
	self setDefaultHandlers! !

!MORoot methodsFor: 'testing' stamp: 'jannik.laval 5/15/2009 13:43'!
isRoot
	^ true! !

!MORoot methodsFor: 'zoom' stamp: 'simondenier 10/27/2009 17:13'!
isZoomOn

	^ false! !

!MORoot methodsFor: 'printing' stamp: 'Alexandre Bergel 7/19/2010 10:51'!
printOn: aStream
	self originalPrintOn: aStream.! !

!MORoot methodsFor: 'cache' stamp: 'Alexandre Bergel 7/18/2010 15:59'!
resetFormCache
	"Do nothing., the root does not have a cache"! !

!MORoot methodsFor: 'cache' stamp: 'Alexandre Bergel 7/14/2010 09:24'!
resetFormCacheUpToTheRoot
	"We do nothing since we are the root"! !

!MORoot methodsFor: 'cache' stamp: 'AlexandreBergel 9/1/2010 19:13'!
resetMetricCachesUpToTheRoot
	"We do nothing since we are the root"! !

!MORoot methodsFor: 'accessing-readonly' stamp: 'tg 4/25/2008 09:58'!
root
	^ self! !

!MORoot methodsFor: 'selectionBox' stamp: 'AlexandreBergel 12/27/2010 22:15'!
selectBoxBounds
	"Return the selection box, note that the two corners cannot be nil"
	self 
		assert: [ selectionBoxCorner1 notNil and: [ selectionBoxCorner2 notNil ] ] 
		description: 'Corners cannot be nil'.
	^ Rectangle encompassing: {selectionBoxCorner1 . selectionBoxCorner2 }.
! !

!MORoot methodsFor: 'selectionBox' stamp: 'AlexandreBergel 6/27/2011 07:54'!
selectElementsFromBox
	
	| rectangle |
	self hasSelectionBox ifFalse: [^ self]. 
	selectionBoxUsage := Time now.
	rectangle := self selectBoxBounds.
	
	(self allNodes 
		select: [:node | (rectangle containsRect: node absoluteBounds)
							and: [ node owner == self ] ]) 
		do: [:v | v announce: (MOElementSelection new element: v; setAsMultiple ) ]! !

!MORoot methodsFor: 'accessing' stamp: 'AlexandreBergel 6/27/2011 07:28'!
selectionBoxCorner1
	^ selectionBoxCorner1! !

!MORoot methodsFor: 'accessing' stamp: 'AlexandreBergel 6/27/2011 07:28'!
selectionBoxCorner2
	^ selectionBoxCorner2! !

!MORoot methodsFor: 'selection' stamp: 'tg 4/26/2008 00:18'!
selections
	^selections! !

!MORoot methodsFor: 'configuration' stamp: 'AlexandreBergel 6/27/2011 06:56'!
setDefaultHandlers
	"Install the default event handler for the root"
	
	self setDefaultHandlersMouseMove.
	self setDefaultHandlersMouseDown.! !

!MORoot methodsFor: 'configuration' stamp: 'AlexandreBergel 6/27/2011 07:57'!
setDefaultHandlersMouseDown
	"Install the default event handler for the root"

	self interaction
		on: MOMouseDown
		do: [ :ann | 
			"We increase the size of the canvas"
			self expandForEvent: ann.
			"Transcript show: 'debug setDefaultHandlersMouseDown 1 : ', selectionBoxCorner1 printString, ' ', selectionBoxCorner2 printString, '   ', self hasSelectedNodes printString ; cr."
			self hasSelectedNodes
				ifFalse: [
					selectionBoxCorner1 := ann position.
					"Transcript show: 'debug setDefaultHandlersMouseDown 2 : ', selectionBoxCorner1 printString, ' ', selectionBoxCorner2 printString ; cr."
					self updateWindow ] ].
	self interaction
		on: MOMouseUp
		do: [:ann | selectionBoxCorner2 := selectionBoxCorner1 := nil ]! !

!MORoot methodsFor: 'configuration' stamp: 'AlexandreBergel 6/27/2011 07:53'!
setDefaultHandlersMouseMove
	"Install the default event handler for the root"
	
	self interaction 
		on: MOMouseDrag do: [ :ann |
			selectionBoxCorner1 notNil ifTrue: [
				self expandForEvent: ann.
				self selectElementsFromBox.
				selectionBoxCorner2 :=  ann position.
				self updateWindow ] 
			]
! !

!MORoot methodsFor: 'testing cache' stamp: 'Alexandre Bergel 7/15/2010 21:10'!
shouldCache
	^ false! !

!MORoot methodsFor: 'selectionBox' stamp: 'AlexandreBergel 9/6/2010 09:53'!
shouldDeselect
	selectionBoxUsage ifNil: [ ^ true ].
	^ (Time now asSeconds - selectionBoxUsage asSeconds) > 1! !

!MORoot methodsFor: 'translation and bounds' stamp: 'Alexandre.Bergel 3/16/2009 22:23'!
translateBy: aPoint 

	self nodes do: [:node | node translateBy: aPoint ]! !

!MORoot methodsFor: 'translation and bounds' stamp: 'Alexandre Bergel 7/26/2010 13:03'!
updateBounds
	| maxWidth maxHeight origin bounds |
	self nodes ifEmpty: [self error: 'This method cannot be called since there is no children, something is going wrong'].
	maxWidth := 0.
	maxHeight := 0.
	self nodes do: [:figure|
		origin := figure origin.
		maxWidth := maxWidth max: (figure width + origin x).
		maxHeight := maxHeight max: (figure height + origin y).
	].

	bounds := self bounds.
	bounds width: maxWidth.
	bounds height: maxHeight.

	
"	minX := self children inject: 10000 into: [:min :figure | min min: (figure origin x)].
	minY := self children inject: 10000 into: [:min :figure | min min: (figure origin y)].
	bounds origin: minX @ minY"
	
	canvas ifNotNil: [ canvas updateBounds ]! !

!MORoot methodsFor: 'cache' stamp: 'Alexandre Bergel 7/15/2010 16:57'!
updateOwner
	"nothing to do here"! !

!MORoot methodsFor: 'accessing-readonly' stamp: 'Alexandre Bergel 1/26/2010 22:02'!
zOrder
	^ 1! !

Object subclass: #MOLayout
	instanceVariableNames: 'edges userDefinedEdges affectedNodes fromPositions toPositions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

!MOLayout commentStamp: '<historical>' prior: 0!
MOLayout is the root of the layout classes. The class belongs to the core.
The class is abstract, meaning that it is not meants to be instantiated.. 

Instance Variables
	affectedNodes:		<Collection>
	edges:		<Object>
	fromPositions:		<Object>
	toPositions:		<Object>
	userDefinedEdges:		<Object>

affectedNodes
	- Contains the list of nodes that must be affected by the layout

edges
	- xxxxx

fromPositions
	- xxxxx

toPositions
	- xxxxx

userDefinedEdges
	- xxxxx
!

!MOLayout classSide methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
forNodes: aCollection
	
	^self new affectedNodes: aCollection! !

!MOLayout classSide methodsFor: 'instance creation' stamp: ' 24/4/08 15:59'!
withEdges: aCollection
	
	^self new initialize userDefinedEdges: aCollection! !

!MOLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
affectedNodes
	
	^affectedNodes! !

!MOLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
affectedNodes: anObject
	
	affectedNodes := anObject! !

!MOLayout methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/7/2010 13:39'!
affectedNodesOf:  aNode 
	^ affectedNodes ifNil: [ aNode nodes ]! !

!MOLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 3/7/2010 13:43'!
applyOn: aNode
	
	self executeOnNode: aNode! !

!MOLayout methodsFor: 'adjusting' stamp: ' 24/4/08 15:59'!
defaultAdjustHeightFor: childrenBounds and: myBounds
	
	| deltaY |
	deltaY := childrenBounds top - myBounds top.
	^childrenBounds height + (2 * deltaY)! !

!MOLayout methodsFor: 'adjusting' stamp: ' 24/4/08 15:59'!
defaultAdjustWidthFor: childrenBounds and: myBounds
	
	| deltaX |
	deltaX := childrenBounds left - myBounds left.
	^childrenBounds width + (2 * deltaX)! !

!MOLayout methodsFor: 'default values' stamp: 'AlexandreBergel 12/29/2010 18:55'!
defaultFromPositions
	^ #()
	! !

!MOLayout methodsFor: 'default values' stamp: 'AlexandreBergel 12/29/2010 18:55'!
defaultToPositions
	^ #()
! !

!MOLayout methodsFor: 'hook' stamp: 'AlexandreBergel 2/25/2011 12:48'!
doExecute: aGraphElement
	
	self subclassResponsibility! !

!MOLayout methodsFor: 'hook' stamp: 'Alexandre Bergel 3/21/2010 12:50'!
doIncrementallyExecute: anElementNode
	"called by refreshLayoutEvery: ms. It is used to convey a feeling of incremental execution."
	
	self doExecute: anElementNode! !

!MOLayout methodsFor: 'hook' stamp: 'AlexandreBergel 12/30/2010 13:09'!
doInitialize: aGraph
	
	aGraph edgesDo: [ :edge | edge isVisible: true ]! !

!MOLayout methodsFor: 'hook' stamp: 'AlexandreBergel 12/29/2010 15:01'!
doPostOnGraph: aGraph
	"Hook method"
! !

!MOLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
edges
	
	^edges! !

!MOLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
edges: aCollection
	
	edges := aCollection! !

!MOLayout methodsFor: 'iterator' stamp: 'AlexandreBergel 12/30/2010 13:50'!
edgesDo: aBlock
	"Iterates over all the edges of the receiver."
	
	edges ifNil: [ ^ self ].
	edges do: aBlock
! !

!MOLayout methodsFor: 'accessing' stamp: 'AlexandreBergel 4/30/2011 10:45'!
executeOnNode: aNodeElement 
	"Execute the layout, myself, on the subnodes of the node element"

	self initializeConnectionPositions: aNodeElement.

	self userDefinedEdges isNil 
		ifTrue: [ self edges: aNodeElement edges copy ]
		ifFalse: 
			[ | flat |
			flat := OrderedCollection new.
			self userDefinedEdges do: 
				[ :each | 
				each value isCollection 
					ifTrue: [ flat addAll: each value ]
					ifFalse: [ flat add: each value ] ].
			self edges: flat ].
	self doInitialize: aNodeElement.
	self doExecute: aNodeElement! !

!MOLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
fromPositions
	
	^fromPositions ifNil: [fromPositions := self defaultFromPositions]! !

!MOLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
fromPositions: anArray
	
	fromPositions := anArray! !

!MOLayout methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/30/2011 10:45'!
initialize
	"Initialization"

	edges := nil! !

!MOLayout methodsFor: 'private' stamp: 'AlexandreBergel 12/30/2010 13:09'!
initializeConnectionPositions: node 
	node edgesDo:
		[ :edge | 
		edge setIfNilFromPositions: self fromPositions.
		edge setIfNilToPositions: self toPositions ]! !

!MOLayout methodsFor: 'testing' stamp: 'Alexandre Bergel 3/1/2010 17:55'!
isLineLayout
	^ false! !

!MOLayout methodsFor: 'private' stamp: 'tg 9/20/2009 19:44'!
toPositions
	
	^toPositions ifNil: [toPositions := self defaultToPositions]! !

!MOLayout methodsFor: 'accessing' stamp: ' 24/4/08 15:59'!
toPositions: anArray
	
	toPositions := anArray! !

!MOLayout methodsFor: 'private' stamp: ' 24/4/08 15:59'!
userDefinedEdges
	
	^userDefinedEdges! !

!MOLayout methodsFor: 'initialize-release' stamp: 'Alexandre.Bergel 3/29/2009 03:19'!
userDefinedEdges: aCollection
	
	userDefinedEdges := aCollection! !

Object subclass: #MOShape
	instanceVariableNames: 'isCached'
	classVariableNames: 'DefaultLineShape DefaultNodeShape'
	poolDictionaries: ''
	category: 'Mondrian-Core'!

!MOShape commentStamp: '<historical>' prior: 0!
MOShape is the root of the shape hierarchy.

MOShape is an abstract class. The following methods needs to be implemented
	#absoluteBoundsFor:	#containsPoint:for:	#display:on:	#heightFor:	#widthFor:

Class collaborations
	MOViewRenderer MOHorizontalLineLayout MOVerticalLineLayout MOAbstractLineLayout MOFormsBuilder MOEasel MOShapeAdaptor MOGraphElement 

Class public API
		#absoluteBoundsFor:	#apply:bounds:	#boundsFor:	#canHandleChildren	#collectAllShapes	#computeBoundsFor:	#computeExtentFor:	#containsPoint:for:	#disableCache	#display:on:	#enableCache	#heightFor:	#isCached	#isChildShape	#isFormsShape	#isLineShape	#isNodeShape	#isShape	#scaleElement:by:
Testing classes
	MondrianTest MOFormsBuilderTest MOViewRendererTest XKCDColorTest MONewFormsBuilderTest MOVisitorTest 

Implementation notes
	MOShape defines the notion of bounds and absolute bounds.

Instance Variables:
	isCached -- boolean -- true if the metrics used have to be cached

Comments written by AlexandreBergel on 26 April 2011
!

!MOShape classSide methodsFor: 'default' stamp: 'AlexandreBergel 4/28/2011 23:30'!
defaultLineShapeClass
	"Return the default line shape class"

	| classes |

	classes := (self allSubclasses select: #isDefaultLineShape).
	classes ifEmpty: [ self error: 'No default shape class' ].
	
	"We take the first class, not perfect, but it should be enough for now"
	^ classes anyOne! !

!MOShape classSide methodsFor: 'default' stamp: 'AlexandreBergel 4/28/2011 23:31'!
defaultLineShapeInstance
	"Return the default line shape"

	| classes |
	DefaultLineShape ifNotNil: [ ^ DefaultLineShape ].

	classes := (self allSubclasses select: #isDefaultLineShape).
	classes ifEmpty: [ self error: 'No default shape class' ].
	
	"We take the first class, not perfect, but it should be enough for now"
	^ DefaultLineShape := classes anyOne new! !

!MOShape classSide methodsFor: 'default' stamp: 'AlexandreBergel 4/28/2011 23:31'!
defaultNodeShapeClass
	"Return the default node shape class"

	| classes |

	classes := (self allSubclasses select: #isDefaultNodeShape).
	classes ifEmpty: [ self error: 'No default shape class' ].
	
	"We take the first class, not perfect, but it should be enough for now"
	^ classes anyOne! !

!MOShape classSide methodsFor: 'default' stamp: 'AlexandreBergel 4/28/2011 23:31'!
defaultNodeShapeInstance
	"Return the default node shape"

	| classes |
	DefaultNodeShape ifNotNil: [ ^ DefaultNodeShape ].

	classes := (self allSubclasses select: #isDefaultNodeShape).
	classes ifEmpty: [ self error: 'No default shape class' ].
	
	"We take the first class, not perfect, but it should be enough for now"
	^ DefaultNodeShape := classes anyOne new! !

!MOShape classSide methodsFor: 'initialize' stamp: 'AlexandreBergel 4/28/2011 23:38'!
initialize 
	"Set the shape cache to nil"

	DefaultNodeShape := nil.
	DefaultLineShape := nil! !

!MOShape classSide methodsFor: 'testing' stamp: 'AlexandreBergel 4/29/2011 16:57'!
isDefaultLineShape
	"True if I am the default line shape class. I am meant to be overriden. Note that it is assumed to have only one class that answers true"

	^ false! !

!MOShape classSide methodsFor: 'testing' stamp: 'Alexandre Bergel 6/17/2010 12:16'!
isDefaultNodeShape
	^ false! !

!MOShape methodsFor: 'public' stamp: 'AlexandreBergel 4/28/2011 18:45'!
absoluteBoundsFor: aGraphElement
	"Answer the bounds in absolute terms (relative to the entire Canvas, not just the parent)."

	self subclassResponsibility ! !

!MOShape methodsFor: 'visitor' stamp: 'AlexandreBergel 6/26/2011 17:19'!
acceptVisitor: aVisitor
	self subclassResponsibility! !

!MOShape methodsFor: 'public' stamp: 'AlexandreBergel 4/28/2011 23:41'!
boundsFor: aGraphElement
	"Return the relative bounds of aGraphElement"

	aGraphElement shapeBoundsAt: self ifPresent: [ :b | ^ b ].
	^ self computeBoundsFor: aGraphElement! !

!MOShape methodsFor: 'testing' stamp: 'AlexandreBergel 4/7/2011 14:13'!
canHandleChildren
	^ false! !

!MOShape methodsFor: 'public' stamp: 'Alexandre Bergel 6/25/2010 23:01'!
computeBoundsFor: anElement 
	"Return the bounds with a relative origin"
	
	^ 0@0 corner: (self computeExtentFor: anElement) asNonFractionalPoint
! !

!MOShape methodsFor: 'public' stamp: 'AlexandreBergel 5/4/2011 14:36'!
computeExtentFor: anElement 
	"Compute the extent of an element"

	self subclassResponsibility ! !

!MOShape methodsFor: 'testing' stamp: 'AlexandreBergel 4/28/2011 18:01'!
containsPoint: aPoint for: anElement
	"True if aPoint is contained within the bounds of anElement graphical representation"

	self subclassResponsibility! !

!MOShape methodsFor: 'public' stamp: 'AlexandreBergel 4/28/2011 23:42'!
disableCache
	"Disable metric caches"

	isCached := false! !

!MOShape methodsFor: 'public' stamp: 'AlexandreBergel 4/28/2011 23:42'!
enableCache
	"Enable metric caches"

	isCached := true! !

!MOShape methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 4/28/2011 17:58'!
heightFor: element
	"Return the height of the shape, for the giving graph element"
	
	self subclassResponsibility ! !

!MOShape methodsFor: 'initialize-release' stamp: 'AlexandreBergel 4/28/2011 23:43'!
initialize
	"Each shape is cached per default"

	super initialize.
	isCached := true

! !

!MOShape methodsFor: 'testing' stamp: 'AlexandreBergel 4/28/2011 23:43'!
isCached
	"True if metrics are cached"

	^ isCached! !

!MOShape methodsFor: 'testing' stamp: 'AlexandreBergel 4/28/2011 17:59'!
isChildShape
	"True if I am a child shape. This method is intended to be overriden."

	^ false ! !

!MOShape methodsFor: 'testing' stamp: 'AlexandreBergel 4/28/2011 17:59'!
isFormsShape
	"True if I am a form shape. This method is intended to be overriden."

	^ false! !

!MOShape methodsFor: 'testing' stamp: 'AlexandreBergel 4/28/2011 17:59'!
isLineShape
	"True if I am a line shape. This method is intended to be overriden."

	^ false! !

!MOShape methodsFor: 'testing' stamp: 'AlexandreBergel 4/28/2011 23:43'!
isNodeShape
	"True if I am an instance of one of the subclass of MOLineShape"

	^ self isLineShape not! !

!MOShape methodsFor: 'scaling' stamp: 'AlexandreBergel 4/28/2011 23:39'!
scaleElement: anElement by: aNumber
	"Scale an element by a value"

	anElement shapeBoundsAt: self put: ((anElement shapeBoundsAt: self) scaleBy: aNumber).! !

!MOShape methodsFor: 'public' stamp: 'AlexandreBergel 4/28/2011 18:47'!
updateBounds: anElement for: aBounds
	aBounds extent: (self computeExtentFor: anElement).
	^ aBounds! !

!MOShape methodsFor: 'accessing-computed' stamp: 'AlexandreBergel 4/28/2011 17:58'!
widthFor: element
	"Return the width of the shape, for the giving graph element"

	self subclassResponsibility ! !

Object subclass: #MOViewRenderer
	instanceVariableNames: 'announcer root shape title defaultNodeShapeInstance defaultLineShapeInstance userCommands'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mondrian-Core'!

!MOViewRenderer commentStamp: 'tg 4/24/2008 01:30' prior: 0!
TODO:
- bounds should be computed by Shape
- Make the edge dependent on the Nodes.


Instance Variables
	announcer:		<Object>
	edgeShape:		<Object>
	element:		<Object>
	graph:		<Object>
	layout:		<Object>
	nodeShape:		<Object>

announcer
	- xxxxx

edgeShape
	- xxxxx

element
	- xxxxx

graph
	- xxxxx

layout
	- xxxxx

nodeShape
	- xxxxx
!

!MOViewRenderer classSide methodsFor: 'public' stamp: 'Alexandre Bergel 3/15/2010 18:58'!
title: aTitle
	^ self new title: aTitle; yourself! !

!MOViewRenderer methodsFor: 'convenient' stamp: 'AlexandreBergel 10/3/2011 11:00'!
addEdgeFromNode: source toNode: target
	"Add an edge by specifying its extreminities as MONode. No lookup of the domain is involved"

	^ self addEdgeFromNode: source toNode: target model: {source -> target}! !

!MOViewRenderer methodsFor: 'convenient' stamp: 'AlexandreBergel 10/3/2011 11:01'!
addEdgeFromNode: source toNode: target model: model
	"Add an edge by specifying its extreminities as MONode. No lookup of the domain is involved"

	^ self addEdgeFromNode: source toNode: target model: model shape: self edgeShape ! !

!MOViewRenderer methodsFor: 'convenient' stamp: 'AlexandreBergel 10/3/2011 10:58'!
addEdgeFromNode: source toNode: target model: model shape: aShape
	"Add an edge by specifying its extreminities as MONode. No lookup of the domain is involved"

	^ self addEdgeIn: OrderedCollection new from: source to: target model: model shape: aShape! !

!MOViewRenderer methodsFor: 'private' stamp: 'TudorGirba 5/26/2012 22:53'!
addEdgeIn: aCollection from: source to: target model: model shape: aShape

	| edge |		
	(source notNil and: [ target notNil ]) ifTrue: 
		[ (source ~= target) ifTrue: [ "An edge is between two different nodes "
			edge := MOEdge from: source to: target.
			edge model: model.
			edge shape: aShape.
			edge setAnnouncer: announcer.
			(source mostSpecificParentCommonWith: target) addEdge: edge.
			aCollection addLast: edge ] ]! !

!MOViewRenderer methodsFor: 'commands' stamp: 'AlexandreBergel 12/20/2010 16:57'!
addUserCommand: aCommandClass
	self userCommands add: aCommandClass! !

!MOViewRenderer methodsFor: 'announce' stamp: 'Alexandre.Bergel 2/3/2009 23:50'!
announce: ann
	"^ self announcer announce: ann"
	ann element announcer announce: ann! !

!MOViewRenderer methodsFor: 'announce' stamp: 'Alexandre.Bergel 2/2/2009 09:00'!
announcer
	^ announcer ifNil: [ announcer := self defaultAnnouncer ]! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 4/26/2010 23:12'!
bottomFlowLayout
	^self layout: MOBottomFlowLayout new.! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'AlexandreBergel 12/29/2010 18:34'!
bulletTreeLayout
	^self layout: MOBulletTreeLayout new.! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre.Bergel 4/30/2009 14:55'!
circleLayout
	^self layout: MOCircleLayout new.! !

!MOViewRenderer methodsFor: 'announce' stamp: 'Alexandre Bergel 12/17/2009 18:53'!
defaultAnnouncer
	^ MOAnnouncer new viewRenderer: self! !

!MOViewRenderer methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 10/15/2009 20:05'!
defaultLineShapeClass 
	^ MOEdge defaultLineShapeClass
! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/26/2010 13:07'!
defaultLineShapeInstance
	^ defaultLineShapeInstance! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/26/2010 13:07'!
defaultLineShapeInstance: anObject
	defaultLineShapeInstance := anObject! !

!MOViewRenderer methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 10/15/2009 20:05'!
defaultNodeShapeClass 
	^ MONode defaultNodeShapeClass
! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/26/2010 13:08'!
defaultNodeShapeInstance
	^ defaultNodeShapeInstance! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/26/2010 13:08'!
defaultNodeShapeInstance: anObject
	defaultNodeShapeInstance := anObject! !

!MOViewRenderer methodsFor: 'accessing-computed' stamp: 'Alexandre.Bergel 2/25/2009 21:44'!
domain
	^ self root nodes collect: [ :each | each model ]! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre.Bergel 5/14/2009 00:47'!
dominanceTreeLayout
	^self layout: MODominanceTreeLayout new.! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:44'!
edge: anObject from: aFromBlock to: aToBlock
	"Add an edge going from (aFromBlock moValue: anObject) to (aToBlock moValue: anObject)"

	^ (self edges: (OrderedCollection with: anObject) from: aFromBlock to: aToBlock) first! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:44'!
edge: anObject from: aFromBlock to: aToBlock using: aShape
	"Add an edge going from (aFromBlock moValue: anObject) to (aToBlock moValue: anObject) using a user defined shape"

	^self edges: (OrderedCollection with: anObject) from: aFromBlock to: aToBlock using: aShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 12/4/2011 10:37'!
edge: anObject from: aFromBlock toAll: aToBlock
	"Add an edge going from (aFromBlock moValue: anObject) to all edges (aToBlock moValue: anObject)"

	^ (self edges: (OrderedCollection with: anObject) from: aFromBlock toAll: aToBlock)! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 2/25/2009 21:45'!
edgeFrom: aFromBlock to: aToBlock
	
	^self edges: self domain from: aFromBlock to: aToBlock! !

!MOViewRenderer methodsFor: 'rendering shape' stamp: 'Alexandre Bergel 6/26/2010 13:27'!
edgeShape
	(shape isNil or: [ shape isNodeShape ]) 
		ifTrue: [ 
			self defaultLineShapeInstance ifNotNilDo: [ :s | ^ shape := s ].
			shape := self defaultLineShapeClass new ].
	^ shape! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/25/2009 22:12'!
edgeShape: aShape
	^ self shape: aShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:49'!
edges: aCollectionOfEntities from: aFromBlock
	"- aCollectionOfEntities is the collection of from which the edges are defined from.
	- aFromBlock will be called on each element of the collection and return one edge source each time.
	Note that there is no restriction on the elements of aCollection, as long as aFromBlock returns a node.
	"

	^ self edges: aCollectionOfEntities from: aFromBlock to: [ :anObject | anObject ]! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:49'!
edges: aCollectionOfEntities from: aFromBlock to: aToBlock
	"-  aCollectionOfEntities is the collection of from which the edges are defined from.
	- aFromBlock will be called on each element of the collection and return one edge source each time.
	- aToBlock will be called on each element of the collection and return the destination node.
	Note that there is no restriction on the elements of aCollection, as long as aFromBlock returns a node.
	"
	^ self edges: aCollectionOfEntities from: aFromBlock to: aToBlock using: self edgeShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:49'!
edges: aCollectionOfEntities from: aFromBlock to: aToBlock fromGlobal: fromGlobal toGlobal: toGlobal 
	" aCollectionOfEntities is the collection of from which the edges are defined from."

	^ self edges: aCollectionOfEntities from: aFromBlock to: aToBlock using: self edgeShape fromGlobal: fromGlobal toGlobal: toGlobal ! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:42'!
edges: aCollectionOfEntities from: aFromBlock to: aToBlock using: aShape 
	"Same than edges:from:to: but with using a shape"
	
	^ self edges: aCollectionOfEntities from: aFromBlock to: aToBlock using: aShape fromGlobal: false toGlobal: true! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:43'!
edges: aCollectionOfEntities from: aFromBlock to: aToBlock using: aShape fromGlobal: fromGlobal toGlobal: toGlobal 
	"Same than edges:from:to:using: however, the lookup of the edges may be adjusted. 
	fromGlobal and toGlobal are boolean"

	| source target edges |
	edges := OrderedCollection new.
	aCollectionOfEntities do: 
		[ :each |
			source := self lookupNode: (aFromBlock moValue: each) globally: fromGlobal.
			target := self lookupNode: (aToBlock moValue: each) globally: toGlobal.
			self addEdgeIn: edges from: source to: target model: each shape: aShape].
	self resetInteraction.
	self root resetElementsToDisplayCacheRecursively.
	^ edges! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'TudorGirba 7/1/2011 12:43'!
edges: aCollectionOfEntities from: aFromBlock toAll: aToBlock
	"- aCollectionOfEntities is the collection of from which the edges are defined from.
	- aFromBlock will be called on each entity of the collection and return one edge source each time.
	- aToBlock will be called similarly to return a collection of destination correpsonding to each source.
	Note that there is no restriction on the entities of aCollection, as long as aFromBlock returns a node and aToBlock returns a collection of nodes.
	For example:
	  aView edges: someFamixInvocations from: #sender toAll: #candidates

	Or:
	
	| collection |
	collection := #(1 2 3 4 5 6 7 8 9 10).
	view shape label.
	view nodes: collection.
	view edges: collection from: #yourself toAll: (collection select: #odd).
	view circleLayout
		
	aToBlock should return a collection, edges will be drawn from the entity returned by aFromBlock to this collection"
	
	^self edges: aCollectionOfEntities from: aFromBlock toAll: aToBlock using: self edgeShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:43'!
edges: aCollectionOfEntities from: aFromBlock toAll: aToBlock using: aShape 
	"Same than edges:from:toAll: but a shape is provided"
	
	^self edges: aCollectionOfEntities from: aFromBlock toAll: aToBlock using: aShape fromGlobal: false toGlobal: true! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:43'!
edges: aCollectionOfEntities from: aFromBlock toAll: aToBlock using: aShape fromGlobal: fromGlobal toGlobal: toGlobal 
	"Same than edges:from:toAll:using: but the lookup can be particularized
	fromGlobal and toGlobal are boolean values"

	| source target edges targetModels |
	edges := OrderedCollection new.
	aCollectionOfEntities do: 
		[ :each | 
			source := self lookupNode: (aFromBlock moValue: each) globally: fromGlobal.		
	
			targetModels := aToBlock moValue: each.
			self 
				assert: [targetModels isCollection or: [targetModels isNil]]
				description: 'destination nodes is not a collection'.
			targetModels ifNotNil: [
				targetModels do: [ :targetModel | 
					target := self lookupNode: targetModel globally: toGlobal.
					self addEdgeIn: edges from: source to: target model: each shape: aShape ]]].
	self resetInteraction.
	self root resetElementsToDisplayCacheRecursively.
	^ edges! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:49'!
edges: aCollectionOfEntities fromAll: aFromBlock to: aToBlock
	" aCollectionOfEntities is the collection of from which the edges are defined from."
	"aFromBlock should return a collection, edges will be drawn from this collection to the element returned by aToBlock"
	
	^self edges: aCollectionOfEntities fromAll: aFromBlock to: aToBlock using: self edgeShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:50'!
edges: aCollectionOfEntities fromAll: aFromBlock to: aToBlock using: aShape 
	" aCollectionOfEntities is the collection of from which the edges are defined from."
	"aFromBlock returns a collection of starting nodes"
	
	^self edges: aCollectionOfEntities fromAll: aFromBlock to: aToBlock using: aShape fromGlobal: false toGlobal: true! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:43'!
edges: aCollectionOfEntities fromAll: aFromBlock to: aToBlock using: aShape fromGlobal: fromGlobal toGlobal: toGlobal 
	"same than edges:from:to:using:fromglobal:toGlobal: but on multiple edges
	aFromBlock has to return a collection of starting node
	fromGlobal and toGlobal must be boolean"
	
	| source target edges sourceModels |
	edges := OrderedCollection new.
	aCollectionOfEntities do: 
		[ :each | 
			target := self lookupNode: (aToBlock moValue: each) globally: toGlobal.		
	
			sourceModels := aFromBlock moValue: each.
			self 
				assert: [sourceModels isCollection or: [sourceModels isNil]]
				description: 'destination nodes is not a collection'.
			sourceModels ifNotNil: [
				sourceModels do: [ :sourceModel | 
					source := self lookupNode: sourceModel globally: fromGlobal.
					self addEdgeIn: edges from: source to: target model: each shape: aShape ]]].
	self resetInteraction.
	self root resetElementsToDisplayCacheRecursively.
	^ edges! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'TudorGirba 5/13/2011 16:35'!
edges: aCollection fromAll: aFromBlock toAll: aToBlock
	"both aFromBlock and aToBlock must return a collection"
	
	^self edges: aCollection fromAll: aFromBlock toAll: aToBlock using: self edgeShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'TudorGirba 5/13/2011 16:35'!
edges: aCollection fromAll: aFromBlock toAll: aToBlock using: aShape 
	"both aFromBlock and aToBlock must return a collection"
	
	^self edges: aCollection fromAll: aFromBlock toAll: aToBlock using: aShape fromGlobal: false toGlobal: true! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'TudorGirba 5/13/2011 16:33'!
edges: aCollection fromAll: aFromBlock toAll: aToBlock using: aShape fromGlobal: fromGlobal toGlobal: toGlobal 
	"both aFromBlock and aToBlock must return a collection
	fromGlobal and toGlobal are boolean values"
	
	| edges localEdges |
	edges := OrderedCollection new.

	aCollection do: [:each |
		self shape: aShape.
		localEdges := self 
						edges: (aFromBlock moValue: each)
						from: #yourself
						toAll: [:x | aToBlock moValue: each].
		edges addAll: localEdges
	].

	^ edges! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 6/20/2011 08:50'!
edges: aCollectionOfEntities to: aToBlock
	"Edges are defined for each element of aCollectionOfEntities to the destination node given by aToBlock"
	
	^ self edges: aCollectionOfEntities from: [ :anObject | anObject ] to: aToBlock ! !

!MOViewRenderer methodsFor: 'convenient' stamp: 'AlexandreBergel 9/12/2011 10:08'!
edgesFrom: aBlockOrSelector 
	"The message edgesFrom: defines one edge per node. For each node that has been added in the visualization, an edge is defined between this node and a node lookup from the provided block."
	
	^ self 
		edges: self domain
		from: aBlockOrSelector
		to: #yourself! !

!MOViewRenderer methodsFor: 'convenient' stamp: 'AlexandreBergel 9/18/2010 20:07'!
edgesFrom: aBlockOrSelector fromGlobal: fromGlobal toGlobal: toGlobal

	^ self 
		edges: self domain
		from: aBlockOrSelector
		to: #yourself
		fromGlobal: fromGlobal 
		toGlobal: toGlobal! !

!MOViewRenderer methodsFor: 'convenient' stamp: 'AlexandreBergle 1/20/2011 11:23'!
edgesFromAssociations: associations
	^ self edges: associations from: #key to: #value! !

!MOViewRenderer methodsFor: 'convenient' stamp: 'AlexandreBergel 10/4/2011 08:46'!
edgesTo: aBlockOrSelector 
	"The message edgesTo: defines one edge per node. For each node that has been added in the visualization, an edge is defined between this node and a node lookup from the provided block."
	
	^ self 
		edges: self domain
		from: #yourself
		to: aBlockOrSelector! !

!MOViewRenderer methodsFor: 'convenient' stamp: 'tg 2/26/2010 19:23'!
edgesToAll: aBlockOrSelector 

	^ self 
		edges: self domain
		from: #yourself
		toAll: aBlockOrSelector! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'AlexandreBergel 2/21/2011 13:27'!
fadeLayout
	^ self layout: MOFADELayout new.
! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 9/28/2009 23:34'!
flowLayout
	^self layout: MOFlowLayout new.! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 12/16/2010 16:47'!
forNode: aValue do: aBlock
	"Enable one to add a subview for a given node"
	
	| node oldPos|
	"For some strange reason, doing an applyLayout reset to 0@0 the origin of the node, it should not"
	
"	node := self nodeForDomainValue: aValue."
	node := self lookupNode: aValue globally: true.
	
	"Not sure why we need a reset cache."
"	node allEdgesDo: #resetCache. 
	node owner updateBounds.
	node nodes copy do: #remove.
"
	node removeAllEdges; removeAllNodes.
	node clearLookupCacheRecursively.
	
	oldPos := node bounds origin.
	self with: node during: [ self resetInteraction. aBlock value. node applyLayout ].
	node bounds origin: oldPos. 

	node bounds extent: (node shape computeExtentFor: node).
	node resetFormCache.
	node owner ifNotNil: [ node owner resetFormCache ].
	
	"We might have to update the bounds of the root"
	(node owner isRoot and: [( node owner absoluteBounds containsRect: node absoluteBounds) not])
		ifTrue: [ node owner updateBounds ].
		
	self root resetElementsToDisplayCacheRecursively.
	self root resetElementsToLookup.
	self resetInteraction.
	^ node! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre Bergel 1/12/2010 14:20'!
forNodes: values do: oneBlockArg
	"Enable one to add a subview for a given nodes"

	^ values collect: [:v | self forNode: v do: [ oneBlockArg value: v ] ]! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre.Bergel 5/14/2009 00:48'!
forceBasedLayout
	^self layout: MOForceBasedLayout new.! !

!MOViewRenderer methodsFor: 'debugging' stamp: 'AlexandreBergel 1/10/2011 15:56'!
getRenderedForm
	"Simulate the graphical morph rendering"
	"Nodes need to be layouted before calling this method"

	^ self getRenderedFormSized: self root bounds ! !

!MOViewRenderer methodsFor: 'debugging' stamp: 'SantiagoVidal 5/16/2011 13:40'!
getRenderedFormSized: bounds
	"Simulate the graphical morph rendering"
	"Nodes need to be layouted before calling this method"

	| form canvas |
	form := Form extent: bounds extent depth: Display depth.
	canvas := FormCanvas on: form.
	canvas translateBy: bounds origin negated during:
		[ :aCanvas | self root acceptVisitor: (MOMorphPainterVisitor newCanvas:  aCanvas).].
	
	^ form
! !

!MOViewRenderer methodsFor: 'private' stamp: 'simon.denier 7/3/2009 18:47'!
globalLookupNode: aModel

	^ self root root 
			nodeWith: aModel
			ifAbsent: [ self root root 
					firstSubnodeThat: [:aNode | aNode model = aModel] ]! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'AlexandreBergel 2/21/2011 13:27'!
gridLayout
	^ self layout: MOGridLayout new.
! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre.Bergel 5/14/2009 00:48'!
horizontalDominanceTreeLayout
	^self layout: MOHorizontalDominanceTreeLayout new.! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 5/22/2008 12:22'!
horizontalLineLayout
	^self layout: MOHorizontalLineLayout new.! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 7/25/2010 14:44'!
horizontalNarrowTreeLayout

	^ self layout: MOHorizontalNarrowTreeLayout new! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 9/23/2009 14:43'!
horizontalTreeLayout
	^self layout: MOHorizontalTreeLayout new.! !

!MOViewRenderer methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 7/26/2010 15:01'!
initialize
	root := MORoot new.
	self resetInteraction.
	self title: 'Mondrian Renderer' translated! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'jannik.laval 3/6/2009 16:24'!
interaction
	^ self announcer! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/2/2010 14:21'!
layout
	^ self root layout ifNil: [ self root layout: MOHorizontalLineLayout new ]! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre.Bergel 9/26/2009 14:17'!
layout: anObject 

	self root layout: anObject.
	^ anObject! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 3/29/2009 15:39'!
localEdges: aCollection from: aFromBlock to: aToBlock using: aShape 
	^self edges: aCollection from: aFromBlock to: aToBlock using: aShape fromGlobal: false toGlobal: false.! !

!MOViewRenderer methodsFor: 'private' stamp: 'AlexandreBergel 9/12/2010 18:08'!
localLookupNode: aModel

	^ self root 
			nodeWith: aModel	
			ifAbsent: [ self root 
					firstSubnodeThat: [:aNode | aNode model = aModel] 
					ifAbsent: [ self globalLookupNode: aModel] ]! !

!MOViewRenderer methodsFor: 'private' stamp: 'simon.denier 7/3/2009 18:45'!
lookupNode: aModel globally: aBoolean

	^ aBoolean
			ifTrue: [ self globalLookupNode: aModel ]
			ifFalse: [ self localLookupNode: aModel ].! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre Bergel 6/14/2010 15:23'!
minimumGridLayout
	^ self layout: MOMinimumGridLayout new.

! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 7/25/2010 14:44'!
narrowTreeLayout

	^ self layout: MOVerticalNarrowTreeLayout new.! !

!MOViewRenderer methodsFor: 'events' stamp: 'Alexandre.Bergel 9/26/2009 13:58'!
noInteraction
	announcer := nil! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 3/29/2009 15:33'!
node: anObject

	| coll |
	coll := self nodes: (OrderedCollection with: anObject).
	^ coll first! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 3/29/2009 20:48'!
node: anObject forIt: aZeroArgBlock

	^ (self nodes: (OrderedCollection with: anObject) forEach: [:each | aZeroArgBlock value]) first! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre Bergel 11/30/2009 23:54'!
node: anObject using: aShape
	| collection |
	collection := self nodes: (OrderedCollection with: anObject) using: aShape.
	^collection first! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 3/29/2009 15:32'!
node: anObject using: aShape forIt: aZeroArgBlock
	| collection |
	collection := self nodes: (OrderedCollection with: anObject) using: aShape forEach: [:each | aZeroArgBlock value].
	^collection first! !

!MOViewRenderer methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 4/2/2010 19:00'!
nodeForDomainValue: anObject
	"Returns the MONode corresponding to the value anObject"
	
	^ self root nodeForDomainValue: anObject! !

!MOViewRenderer methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 4/2/2010 19:00'!
nodeForDomainValue: anObject ifAbsent: aBlock
	"Returns the MONode corresponding to the value anObject"
	
	^ self root nodeForDomainValue: anObject ifAbsent: aBlock! !

!MOViewRenderer methodsFor: 'accessing-computed' stamp: 'Alexandre Bergel 4/2/2010 19:01'!
nodeForDomainValues: aCollection
	"Returns the MONode corresponding to the values contained in aCollection"
	^ self root nodeForDomainValues: aCollection! !

!MOViewRenderer methodsFor: 'rendering shape' stamp: 'Alexandre Bergel 6/26/2010 13:19'!
nodeShape
	(shape isNil or: [ shape isLineShape ]) 
		ifTrue: [ 
			self defaultNodeShapeInstance ifNotNilDo: [ :s | ^ shape := s ].
			shape := self defaultNodeShapeClass new ].
	^ shape
! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/25/2009 20:19'!
nodeShape: aShape
	self shape: aShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre.Bergel 3/29/2009 15:33'!
nodes: aCollection

	^ self nodes: aCollection using: self nodeShape! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'tg 4/24/2008 14:34'!
nodes: aCollection forEach: aBlock


	^self nodes: aCollection using: self nodeShape forEach: aBlock! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'Alexandre Bergel 2/26/2010 15:10'!
nodes: aCollection using: aShape 
	| nodes newNode |

	self assert: [ aCollection isCollection ] description: 'A collection should be provided, else use #node: instead'.

	nodes := aCollection collect: 
		[ :anEntity | 
		newNode := MONode new.
		newNode model: anEntity.
		newNode shape: aShape.
		newNode setAnnouncer: announcer.
		self root addNode: newNode.
		newNode ].

	self resetDefaults.
	^ nodes! !

!MOViewRenderer methodsFor: 'rendering base' stamp: 'AlexandreBergel 4/7/2011 14:13'!
nodes: aCollection using: aShape forEach: aBlock

	| newNodes |
"	aShape canHandleChildren ifFalse: [ self error: 'Inner nodes cannot be added. The shape cannot handle children' ]."

	newNodes := self nodes: aCollection using: aShape.
	
	newNodes do: [ :eachNode |
		self with: eachNode during: [self resetInteraction. aBlock value: eachNode model]
	].
	self resetInteraction.
	^newNodes! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre.Bergel 5/14/2009 01:42'!
radialTreeLayout
	^self layout: MORadialTreeLayout new.! !

!MOViewRenderer methodsFor: 'initialize-release' stamp: 'Alexandre Bergel 3/21/2010 20:14'!
resetDefaults

	self shape: nil.
	self resetInteraction.! !

!MOViewRenderer methodsFor: 'events' stamp: 'Alexandre.Bergel 3/31/2009 19:36'!
resetInteraction
	announcer := nil.
	self setUsefulHandlersForNodes.! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/20/2009 20:22'!
root
	^ root! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre.Bergel 2/20/2009 20:38'!
root:  aMORoot 
	root := aMORoot! !

!MOViewRenderer methodsFor: 'events' stamp: 'AlexandreBergel 9/6/2010 18:43'!
setDefaultHandlerForWindow: systemWindow
	self root announcer 
		on: MOWindowStatusChanged
		do: [ :ann | | rootLabel |
				rootLabel := 
					(systemWindow label includes: $:)
						ifTrue: [ systemWindow label copyUpTo: $: ]
						ifFalse: [ systemWindow label ].
				ann newLabel 
					ifNotEmpty: [systemWindow setLabel: (rootLabel, ': ', ann newLabel)]
					ifEmpty: [ systemWindow setLabel: rootLabel ].
				 ]! !

!MOViewRenderer methodsFor: 'events' stamp: 'AlexandreBergel 9/6/2010 09:53'!
setDefaultHandlers
	"This method is called when the nodes have been added to the view"

	"@@WHY this handlers are set here? And not in MORoot"
	self root announcer 
		subscribe: MOMouseDown
		do: 
			[ :ann | 
			self root shouldDeselect ifTrue:
				[ self root allSelectedNodes do: [ :node | node deselect ] ].
			self updateWindow ].

	"this subscription is triggered by updateWindow"
	self root announcer 
		subscribe: MOContentChanged
		do: [ :ann | self root canvas changed ].
! !

!MOViewRenderer methodsFor: 'events' stamp: 'AlexandreBergel 1/27/2011 09:19'!
setUsefulHandlersForNodes
	"Set a number of useful handlers for nodes"
	self interaction draggable.
	self interaction popupText.
	self interaction on: MOElementSelection 
		do: [:ann |
				ann isUnique  
					ifTrue: [ self root allSelectedNodes 
								do: [ :node | 
										node 
											deselect;
											announce: (MOElementDeselection new) ] ].
				ann element select.
				self updateWindow ].
! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 6/26/2010 13:29'!
shape: anObject
	shape := anObject.
	^ anObject! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'Alexandre Bergel 3/15/2010 18:54'!
springLayout
	^self layout: MOSpringLayout new.! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'AlexandreBergel 12/29/2010 19:16'!
sugiyamaLayout
	^self layout: MOSugiyamaLayout new.! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/15/2010 18:55'!
title
	^ title! !

!MOViewRenderer methodsFor: 'accessing' stamp: 'Alexandre Bergel 3/15/2010 18:55'!
title: anObject
	title := anObject! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 5/22/2008 12:22'!
treeLayout
	^self layout: MOTreeLayout new.! !

!MOViewRenderer methodsFor: 'events' stamp: 'AlexandreBergel 12/4/2011 10:44'!
updateWindow
	"Refresh the content of the window. This happens when some shape change for example"

	self root updateWindow! !

!MOViewRenderer methodsFor: 'commands' stamp: 'AlexandreBergel 12/20/2010 16:58'!
userCommands
	userCommands ifNil: [ userCommands := OrderedCollection new ].
	^ userCommands! !

!MOViewRenderer methodsFor: 'layout - utilities' stamp: 'tg 5/22/2008 12:22'!
verticalLineLayout
	^self layout: MOVerticalLineLayout new.! !

!MOViewRenderer methodsFor: 'private' stamp: 'Alexandre Bergel 3/15/2010 10:43'!
with: anElement during: aBlock
	| state |
	state := self shallowCopy.
	self root: anElement.
	aBlock ensure: [ self copyFrom: state ]
! !

!Object methodsFor: '*mondrian-core-accessing' stamp: 'lr 2/3/2008 13:34'!
moValue: anArgument 
	^ self! !
MOShape initialize!
